#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>
#include <richedit.h>
#include "StackFunc.h"
#include "StrFunc.h"
#include "WideFunc.h"
#include "AkelEdit.h"
#include "AkelDLL.h"
#include "Coder.h"
#include "HighLight.h"
#include "Resources\Resource.h"


//Global variables
HSTACK hHighLightWindowsStack={0};
HSTACK hMarkThemeStack={0};
DWORD dwIgnoreFontStyle=0;
BOOL bAutoMarkEnable=FALSE;
int nAutoMarkType=MARKAUTO_SYMBOLS;
DWORD dwAutoMarkFlags;
DWORD dwAutoMarkFontStyle;
DWORD dwAutoMarkTextColor;
DWORD dwAutoMarkBkColor;
BOOL bUpdateTheme=TRUE;
AEHDOC hDocEditCurrent=NULL;
RECT rcUpdateRect;


//Plugin extern function
void __declspec(dllexport) HighLight(PLUGINDATA *pd)
{
  pd->dwSupport|=PDS_NORICHEDIT;
  if (pd->dwSupport & PDS_GETSUPPORT)
    return;

  if (!bInitCommon)
    InitCommon(pd);
  else if (!bInitHighLight)
    ReadOptions(OF_HIGHLIGHT);

  if (pd->lParam)
  {
    if (bInitHighLight)
    {
      if (IsExtCallParamValid(pd->lParam, 1))
      {
        if (GetExtCallParam(pd->lParam, 1) == DLLA_HIGHLIGHT_MARKSELECTION)
        {
          EDITINFO ei;
          HWINDOWEDIT *lpWindowEdit;
          unsigned char *pStringColor1=NULL;
          unsigned char *pStringColor2=NULL;
          DWORD dwColor1=(DWORD)-1;
          DWORD dwColor2=(DWORD)-1;
          BOOL bMatchCase=TRUE;
          DWORD dwFontStyle=0;
          DWORD dwMarkID=MARKID_TEXT;

          if (IsExtCallParamValid(pd->lParam, 2))
            pStringColor1=(unsigned char *)GetExtCallParam(pd->lParam, 2);
          if (IsExtCallParamValid(pd->lParam, 3))
            pStringColor2=(unsigned char *)GetExtCallParam(pd->lParam, 3);
          if (IsExtCallParamValid(pd->lParam, 4))
            bMatchCase=(BOOL)GetExtCallParam(pd->lParam, 4);
          if (IsExtCallParamValid(pd->lParam, 5))
            dwFontStyle=(DWORD)GetExtCallParam(pd->lParam, 5);
          if (IsExtCallParamValid(pd->lParam, 6))
            dwMarkID=(DWORD)GetExtCallParam(pd->lParam, 6);

          if (bOldWindows)
          {
            if (pStringColor1 && *(char *)pStringColor1 == '#')
              dwColor1=GetColorValueFromStrA((char *)pStringColor1 + 1);
            if (pStringColor2 && *(char *)pStringColor2 == '#')
              dwColor2=GetColorValueFromStrA((char *)pStringColor2 + 1);
          }
          else
          {
            if (pStringColor1 && *(wchar_t *)pStringColor1 == '#')
              dwColor1=GetColorValueFromStrW((wchar_t *)pStringColor1 + 1);
            if (pStringColor2 && *(wchar_t *)pStringColor2 == '#')
              dwColor2=GetColorValueFromStrW((wchar_t *)pStringColor2 + 1);
          }

          if (dwColor1 != (DWORD)-1 || dwColor2 != (DWORD)-1)
          {
            if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)pd->hWndEdit, (LPARAM)&ei))
            {
              if (lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, ei.hWndMaster?ei.hWndMaster:ei.hWndEdit, ei.hDocMaster?ei.hDocMaster:ei.hDocEdit))
              {
                CHARRANGE64 cr;
                wchar_t *wpText;
                int nTextLen=0;
                BOOL bUpdate=FALSE;

                if (UnmarkSelection(lpWindowEdit, dwMarkID))
                  bUpdate=TRUE;
                SendMessage(ei.hWndEdit, EM_EXGETSEL64, 0, (LPARAM)&cr);

                if (cr.cpMax > cr.cpMin && cr.cpMax - cr.cpMin < MARKMAX_WORD)
                {
                  if (wpText=(wchar_t *)SendMessage(hMainWnd, AKD_GETSELTEXTW, (WPARAM)ei.hWndEdit, (LPARAM)&nTextLen))
                  {
                    if (MarkSelection(lpWindowEdit, wpText, nTextLen, dwColor1, dwColor2, bMatchCase, dwFontStyle, dwMarkID))
                      bUpdate=TRUE;
                    SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)wpText);
                  }
                }

                //Update edit
                if (bUpdate)
                  UpdateEditAll(UE_DRAWRECT);
              }
            }
          }
        }
        else if (GetExtCallParam(pd->lParam, 1) == DLLA_HIGHLIGHT_UNMARKSELECTION)
        {
          EDITINFO ei;
          HWINDOWEDIT *lpWindowEdit;
          DWORD dwMarkID=0;

          if (IsExtCallParamValid(pd->lParam, 2))
            dwMarkID=(DWORD)GetExtCallParam(pd->lParam, 2);

          if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)pd->hWndEdit, (LPARAM)&ei))
          {
            if (lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, ei.hWndMaster?ei.hWndMaster:ei.hWndEdit, ei.hDocMaster?ei.hDocMaster:ei.hDocEdit))
            {
              if (UnmarkSelection(lpWindowEdit, dwMarkID))
                UpdateEditAll(UE_DRAWRECT);
            }
          }
        }
        else if (GetExtCallParam(pd->lParam, 1) == DLLA_HIGHLIGHT_CHECKMARKSELECTION)
        {
          EDITINFO ei;
          HWINDOWEDIT *lpWindowEdit;
          DWORD dwMarkID=0;
          BOOL *lpbActive=NULL;

          if (IsExtCallParamValid(pd->lParam, 2))
            dwMarkID=(DWORD)GetExtCallParam(pd->lParam, 2);
          if (IsExtCallParamValid(pd->lParam, 3))
            lpbActive=(BOOL *)GetExtCallParam(pd->lParam, 3);

          if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)pd->hWndEdit, (LPARAM)&ei))
          {
            if (lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, ei.hWndMaster?ei.hWndMaster:ei.hWndEdit, ei.hDocMaster?ei.hDocMaster:ei.hDocEdit))
            {
              if (StackGetMarkText(lpWindowEdit, dwMarkID))
                *lpbActive=TRUE;
              else
                *lpbActive=FALSE;
            }
          }
        }
      }
    }
    else
    {
      xprintfW(wszBuffer, GetLangStringW(wLangModule, STRID_LOADFIRST), L"Coder::HighLight");
      MessageBoxW(pd->hMainWnd, wszBuffer, L"Coder::HighLight", MB_OK|MB_ICONEXCLAMATION);
    }

    //If plugin already loaded, stay in memory and don't change active status
    if (pd->bInMemory) pd->nUnload=UD_NONUNLOAD_UNCHANGE;
    return;
  }

  //Initialize
  if (bInitHighLight)
  {
    UninitMain();
    UninitHighLight();
    UpdateEditAll(UE_DRAWRECT);

    //If any function still loaded, stay in memory and show as non-active
    if (nInitMain) pd->nUnload=UD_NONUNLOAD_NONACTIVE;
  }
  else
  {
    InitMain();
    InitHighLight();
    if (!pd->bOnStart)
    {
      bUpdateTheme=TRUE;
      UpdateEditAll(UE_DRAWRECT);
    }

    //Stay in memory, and show as active
    pd->nUnload=UD_NONUNLOAD_ACTIVE;
  }
}

BOOL CALLBACK HighLightSetupDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndGlobalFontStyleGroup;
  static HWND hWndGlobalFontStyleNormal;
  static HWND hWndGlobalFontStyleBold;
  static HWND hWndGlobalFontStyleItalic;
  static HWND hWndGlobalFontStyleBoldItalic;
  static HWND hWndAutoMarkGroup;
  static HWND hWndAutoMarkEnable;
  static HWND hWndAutoMarkSymbols;
  static HWND hWndAutoMarkWords;
  static HFONT hFontNormal;
  static HFONT hFontBold;
  static HFONT hFontItalic;
  static HFONT hFontBoldItalic;
  BOOL bState;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndGlobalFontStyleGroup=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_GROUP);
    hWndGlobalFontStyleNormal=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_NORMAL);
    hWndGlobalFontStyleBold=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_BOLD);
    hWndGlobalFontStyleItalic=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_ITALIC);
    hWndGlobalFontStyleBoldItalic=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_BOLDITALIC);
    hWndAutoMarkGroup=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_GROUP);
    hWndAutoMarkEnable=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_ENABLE);
    hWndAutoMarkSymbols=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_SYMBOLS);
    hWndAutoMarkWords=GetDlgItem(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_WORDS);

    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_GROUP, GetLangStringW(wLangModule, STRID_IGNORE_FONTSTYLE_GROUP));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_NORMAL, GetLangStringW(wLangModule, STRID_NORMAL));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_BOLD, GetLangStringW(wLangModule, STRID_BOLD));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_ITALIC, GetLangStringW(wLangModule, STRID_ITALIC));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_BOLDITALIC, GetLangStringW(wLangModule, STRID_BOLDITALIC));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_GROUP, GetLangStringW(wLangModule, STRID_AUTOMARK_GROUP));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_ENABLE, GetLangStringW(wLangModule, STRID_ENABLE));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_SYMBOLS, GetLangStringW(wLangModule, STRID_SYMBOLS));
    SetDlgItemTextWide(hDlg, IDC_HIGHLIGHT_SETUP_AUTOMARK_WORDS, GetLangStringW(wLangModule, STRID_WORDS));

    if (dwIgnoreFontStyle & IFS_FONTNORMAL)
      SendMessage(hWndGlobalFontStyleNormal, BM_SETCHECK, BST_CHECKED, 0);
    if (dwIgnoreFontStyle & IFS_FONTBOLD)
      SendMessage(hWndGlobalFontStyleBold, BM_SETCHECK, BST_CHECKED, 0);
    if (dwIgnoreFontStyle & IFS_FONTITALIC)
      SendMessage(hWndGlobalFontStyleItalic, BM_SETCHECK, BST_CHECKED, 0);
    if (dwIgnoreFontStyle & IFS_FONTBOLDITALIC)
      SendMessage(hWndGlobalFontStyleBoldItalic, BM_SETCHECK, BST_CHECKED, 0);
    if (bAutoMarkEnable)
      SendMessage(hWndAutoMarkEnable, BM_SETCHECK, BST_CHECKED, 0);
    if (nAutoMarkType == MARKAUTO_SYMBOLS)
      SendMessage(hWndAutoMarkSymbols, BM_SETCHECK, BST_CHECKED, 0);
    else if (nAutoMarkType == MARKAUTO_WORDS)
      SendMessage(hWndAutoMarkWords, BM_SETCHECK, BST_CHECKED, 0);

    SendMessage(hDlg, WM_COMMAND, IDC_HIGHLIGHT_SETUP_AUTOMARK_ENABLE, 0);

    //Set fonts
    {
      LOGFONTW lfGui;
      HFONT hGuiFont;

      //Default GUI font
      hGuiFont=(HFONT)GetStockObject(DEFAULT_GUI_FONT);
      if (bOldWindows)
      {
        LOGFONTA lfA;

        GetObjectA(hGuiFont, sizeof(LOGFONTA), &lfA);
        LogFontAtoW(&lfA, &lfGui);
      }
      else GetObjectW(hGuiFont, sizeof(LOGFONTW), &lfGui);

      //Create normal font
      lfGui.lfWeight=FW_NORMAL;
      lfGui.lfItalic=FALSE;
      hFontNormal=(HFONT)CreateFontIndirectWide(&lfGui);
      SendMessage(hWndGlobalFontStyleNormal, WM_SETFONT, (WPARAM)hFontNormal, TRUE);

      //Create bold font
      lfGui.lfWeight=FW_BOLD;
      lfGui.lfItalic=FALSE;
      hFontBold=(HFONT)CreateFontIndirectWide(&lfGui);
      SendMessage(hWndGlobalFontStyleBold, WM_SETFONT, (WPARAM)hFontBold, TRUE);

      //Create italic font
      lfGui.lfWeight=FW_NORMAL;
      lfGui.lfItalic=TRUE;
      hFontItalic=(HFONT)CreateFontIndirectWide(&lfGui);
      SendMessage(hWndGlobalFontStyleItalic, WM_SETFONT, (WPARAM)hFontItalic, TRUE);

      //Create bold italic font
      lfGui.lfWeight=FW_BOLD;
      lfGui.lfItalic=TRUE;
      hFontBoldItalic=(HFONT)CreateFontIndirectWide(&lfGui);
      SendMessage(hWndGlobalFontStyleBoldItalic, WM_SETFONT, (WPARAM)hFontBoldItalic, TRUE);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) >= IDC_HIGHLIGHT_SETUP_GLOBAL_FONTSTYLE_GROUP &&
        LOWORD(wParam) <= IDC_HIGHLIGHT_SETUP_AUTOMARK_WORDS)
    {
      SendMessage(hWndPropSheet, PSM_CHANGED, (WPARAM)hDlg, 0);
    }

    if (LOWORD(wParam) == IDC_HIGHLIGHT_SETUP_AUTOMARK_ENABLE)
    {
      bState=(BOOL)SendMessage(hWndAutoMarkEnable, BM_GETCHECK, 0, 0);
      EnableWindow(hWndAutoMarkSymbols, bState);
      EnableWindow(hWndAutoMarkWords, bState);
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == (UINT)PSN_SETACTIVE)
    {
      if (nPropMaxVisitPage < PAGE_HIGHLIGHT)
        nPropMaxVisitPage=PAGE_HIGHLIGHT;
    }
    else if (((NMHDR *)lParam)->code == (UINT)PSN_APPLY)
    {
      PSHNOTIFY *pshn=(PSHNOTIFY *)lParam;

      //Global font style
      dwIgnoreFontStyle=0;
      if (SendMessage(hWndGlobalFontStyleNormal, BM_GETCHECK, 0, 0) == BST_CHECKED)
        dwIgnoreFontStyle|=IFS_FONTNORMAL;
      if (SendMessage(hWndGlobalFontStyleBold, BM_GETCHECK, 0, 0) == BST_CHECKED)
        dwIgnoreFontStyle|=IFS_FONTBOLD;
      if (SendMessage(hWndGlobalFontStyleItalic, BM_GETCHECK, 0, 0) == BST_CHECKED)
        dwIgnoreFontStyle|=IFS_FONTITALIC;
      if (SendMessage(hWndGlobalFontStyleBoldItalic, BM_GETCHECK, 0, 0) == BST_CHECKED)
        dwIgnoreFontStyle|=IFS_FONTBOLDITALIC;

      //Auto mark
      bAutoMarkEnable=(BOOL)SendMessage(hWndAutoMarkEnable, BM_GETCHECK, 0, 0);
      if (SendMessage(hWndAutoMarkSymbols, BM_GETCHECK, 0, 0) == BST_CHECKED)
        nAutoMarkType=MARKAUTO_SYMBOLS;
      else if (SendMessage(hWndAutoMarkWords, BM_GETCHECK, 0, 0) == BST_CHECKED)
        nAutoMarkType=MARKAUTO_WORDS;

      if (pshn->lParam)
      {
        //OK button pressed
        bSaveOptions=TRUE;
      }
      else
      {
        //Apply button pressed
        if (nPropMaxVisitPage == PAGE_HIGHLIGHT)
          UpdateAllOptions();
        return FALSE;
      }
    }

    if (((NMHDR *)lParam)->code == (UINT)PSN_APPLY ||
        ((NMHDR *)lParam)->code == (UINT)PSN_RESET)
    {
      SendMessage(hWndGlobalFontStyleNormal, WM_SETFONT, (WPARAM)NULL, TRUE);
      SendMessage(hWndGlobalFontStyleBold, WM_SETFONT, (WPARAM)NULL, TRUE);
      SendMessage(hWndGlobalFontStyleItalic, WM_SETFONT, (WPARAM)NULL, TRUE);
      SendMessage(hWndGlobalFontStyleBoldItalic, WM_SETFONT, (WPARAM)NULL, TRUE);
      if (hFontNormal) DeleteObject(hFontNormal);
      if (hFontBold) DeleteObject(hFontBold);
      if (hFontItalic) DeleteObject(hFontItalic);
      if (hFontBoldItalic) DeleteObject(hFontBoldItalic);
    }
  }
  return FALSE;
}

LRESULT CALLBACK HighLightEditProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_PAINT)
  {
    HSYNTAXFILE *lpSyntaxFile;
    HWINDOWEDIT *lpWindowEdit;
    HWND hWndMaster=(HWND)SendMessage(hWnd, AEM_GETMASTER, 0, 0);
    AEHDOC hDocEdit;
    DWORD dwLockInherit;

    if (hWndMaster && hWndMaster != hWnd)
    {
      //Ignore theme checking for clones, cause they inherit theme from master
      return FALSE;
    }
    hDocEdit=(AEHDOC)SendMessage(hWnd, AEM_GETDOCUMENT, 0, 0);

    //Check theme
    if (bUpdateTheme || hDocEdit != hDocEditCurrent)
    {
      bUpdateTheme=FALSE;
      hDocEditCurrent=hDocEdit;

      if (lpSyntaxFile=StackGetSyntaxFileByWindow(&hSyntaxFilesStack, hWnd))
        StackRequestSyntaxFile(lpSyntaxFile);

      if (!(lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, hWnd, hDocEdit)))
      {
        if (lpWindowEdit=StackInsertHighLightWindow(&hHighLightWindowsStack))
        {
          lpWindowEdit->hWndEdit=hWnd;
          lpWindowEdit->hDocEdit=hDocEdit;
        }
      }

      if (lpSyntaxFile)
      {
        if (!lpSyntaxFile->hThemeHighLight)
          CreateEditTheme(lpSyntaxFile, hWnd);

        if (lpSyntaxFile->hThemeHighLight != (HANDLE)SendMessage(hWnd, AEM_HLGETTHEMEW, 0, (LPARAM)NULL))
        {
          if (lpWindowEdit)
          {
            //Assign theme
            SendMessage(hWnd, AEM_HLSETTHEME, (WPARAM)lpSyntaxFile->hThemeHighLight, FALSE);

            //Set colors and font
            RestoreFontAndColors(lpWindowEdit);
            GetFontAndColors(lpSyntaxFile, lpWindowEdit);

            if ((dwLockInherit=(DWORD)SendMessage(hMainWnd, AKD_GETLOCKINHERIT, (WPARAM)hWnd, 0)) != (DWORD)-1)
            {
              if (lpWindowEdit->aecNew.dwFlags)
              {
                SendMessage(hMainWnd, AKD_SETCOLORS, (WPARAM)hWnd, (LPARAM)&lpWindowEdit->aecNew);
                dwLockInherit|=LI_COLORS;
              }
              if (lpWindowEdit->dwFontFlags)
              {
                SendMessage(hMainWnd, AKD_SETFONTW, (WPARAM)hWnd, (LPARAM)&lpWindowEdit->lfFontNew);
                dwLockInherit|=LI_FONT;
              }
              SendMessage(hMainWnd, AKD_SETLOCKINHERIT, (WPARAM)hWnd, dwLockInherit);
            }
          }
        }
      }
      else
      {
        //Extension doesn't associated, unassign theme
        if (lpWindowEdit)
        {
          RestoreFontAndColors(lpWindowEdit);
          UnassignTheme(lpWindowEdit->hWndEdit);
        }
      }
    }
  }
  return FALSE;
}

void CALLBACK HighLightEditProcRet(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_PAINT)
  {
    if (!bAkelEdit)
    {
      HSYNTAXFILE *lpSyntaxFile;

      if (lpSyntaxFile=StackGetSyntaxFileByWindow(&hSyntaxFilesStack, hWnd))
      {
        StackRequestSyntaxFile(lpSyntaxFile);

/*
        if (bOldWindows)
          PaintRichEditA(lpSyntaxFile, hWnd, &rcUpdateRect);
        else
          PaintRichEditW(lpSyntaxFile, hWnd, &rcUpdateRect);
*/
      }
    }
  }
}

LRESULT CALLBACK HighLightEditParentMessages(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_OPENDOCUMENT_FINISH ||
      uMsg == AKDN_EDIT_ONCLOSE)
  {
    bUpdateTheme=TRUE;
    UpdateEditAndClones((HWND)wParam, UE_DRAWRECT);
  }
  else if (uMsg == AKDN_SAVEDOCUMENT_START)
  {
    NSAVEDOCUMENT *nsd=(NSAVEDOCUMENT *)lParam;
    EDITINFO ei;

    if (nsd->dwFlags & SD_UPDATE)
    {
      if (SendMessage(hMainWnd, AKD_GETEDITINFO, wParam, (LPARAM)&ei))
      {
        const wchar_t *wpExt1=GetFileExt(nsd->wszFile);
        const wchar_t *wpExt2=GetFileExt(ei.wszFile);

        if (!wpExt1) wpExt1=L"";
        if (!wpExt2) wpExt2=L"";
        if (xstrcmpiW(wpExt1, wpExt2))
          bUpdateTheme=TRUE;
      }
    }
  }
  else if (uMsg == AKDN_SAVEDOCUMENT_FINISH)
  {
    if (bUpdateTheme)
      UpdateEditAndClones((HWND)wParam, UE_DRAWRECT);
  }

  if (uMsg == AKDN_EDIT_ONCLOSE ||
      uMsg == AKDN_EDIT_ONFINISH)
  {
    HWINDOWEDIT *lpWindowEdit;
    HWND hWndMaster=(HWND)SendMessage((HWND)wParam, AEM_GETMASTER, 0, 0);

    if (!hWndMaster || hWndMaster == (HWND)wParam)
    {
      if (hDocEditCurrent == (AEHDOC)lParam)
        hDocEditCurrent=NULL;
      if (lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, (HWND)wParam, (AEHDOC)lParam))
        StackDeleteHighLightWindow(&hHighLightWindowsStack, lpWindowEdit);
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_EDIT)
    {
      if (((NMHDR *)lParam)->code == AEN_TEXTCHANGING)
      {
        AENTEXTCHANGE *aentc=(AENTEXTCHANGE *)lParam;
        HWINDOWEDIT *lpWindowEdit;
        EDITINFO ei;

        if ((aentc->dwType & AETCT_SETTEXT) ||
            (aentc->dwType & AETCT_STREAMIN))
        {
          if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)aentc->hdr.hwndFrom, (LPARAM)&ei))
          {
            if (lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, ei.hWndMaster?ei.hWndMaster:ei.hWndEdit, ei.hDocMaster?ei.hDocMaster:ei.hDocEdit))
            {
              UnmarkSelection(lpWindowEdit, 0);
            }
          }
        }
      }
      else if (((NMHDR *)lParam)->code == AEN_SELCHANGED)
      {
        AENSELCHANGE *aensc=(AENSELCHANGE *)lParam;
        HSYNTAXFILE *lpSyntaxFile;
        DWORD *lpdwAutoMarkFlags;
        DWORD *lpdwAutoMarkFontStyle;
        DWORD *lpdwAutoMarkTextColor;
        DWORD *lpdwAutoMarkBkColor;

        if (lpSyntaxFile=StackGetSyntaxFileByWindow(&hSyntaxFilesStack, aensc->hdr.hwndFrom))
        {
          StackRequestSyntaxFile(lpSyntaxFile);

          lpdwAutoMarkFlags=&lpSyntaxFile->dwAutoMarkFlags;
          lpdwAutoMarkFontStyle=&lpSyntaxFile->dwAutoMarkFontStyle;
          lpdwAutoMarkTextColor=&lpSyntaxFile->dwAutoMarkTextColor;
          lpdwAutoMarkBkColor=&lpSyntaxFile->dwAutoMarkBkColor;
        }
        else
        {
          //Document without syntax theme
          lpdwAutoMarkFlags=&dwAutoMarkFlags;
          lpdwAutoMarkFontStyle=&dwAutoMarkFontStyle;
          lpdwAutoMarkTextColor=&dwAutoMarkTextColor;
          lpdwAutoMarkBkColor=&dwAutoMarkBkColor;
        }

        if (bAutoMarkEnable &&
            (*lpdwAutoMarkFontStyle != AEHLS_NONE ||
             *lpdwAutoMarkTextColor != (DWORD)-1 ||
             *lpdwAutoMarkBkColor != (DWORD)-1))
        {
          HWINDOWEDIT *lpWindowEdit;
          EDITINFO ei;
          CHARRANGE64 cr;

          if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)aensc->hdr.hwndFrom, (LPARAM)&ei))
          {
            if (lpWindowEdit=StackGetHighLightWindow(&hHighLightWindowsStack, ei.hWndMaster?ei.hWndMaster:ei.hWndEdit, ei.hDocMaster?ei.hDocMaster:ei.hDocEdit))
            {
              SendMessage(ei.hWndEdit, EM_EXGETSEL64, 0, (LPARAM)&cr);

              if (cr.cpMax > cr.cpMin && cr.cpMax - cr.cpMin < MARKMAX_WORD &&
                   (nAutoMarkType == MARKAUTO_SYMBOLS ||
                     (nAutoMarkType == MARKAUTO_WORDS &&
                      SendMessage(ei.hWndEdit, AEM_ISDELIMITER, AEDLM_WORD|AEDLM_PREVCHAR, (LPARAM)&aensc->aes.crSel.ciMin) &&
                      !SendMessage(ei.hWndEdit, AEM_ISDELIMITER, AEDLM_WORD, (LPARAM)&aensc->aes.crSel.ciMin) &&
                      SendMessage(ei.hWndEdit, AEM_ISDELIMITER, AEDLM_WORD, (LPARAM)&aensc->aes.crSel.ciMax) &&
                      !SendMessage(ei.hWndEdit, AEM_ISDELIMITER, AEDLM_WORD|AEDLM_PREVCHAR, (LPARAM)&aensc->aes.crSel.ciMax))))
              {
                wchar_t *wpText;
                int nTextLen=0;
                BOOL bUpdate=FALSE;

                if (UnmarkSelection(lpWindowEdit, MARKID_AUTO))
                  bUpdate=TRUE;

                if (wpText=(wchar_t *)SendMessage(hMainWnd, AKD_GETSELTEXTW, (WPARAM)ei.hWndEdit, (LPARAM)&nTextLen))
                {
                  if (MarkSelection(lpWindowEdit, wpText, nTextLen, *lpdwAutoMarkTextColor, *lpdwAutoMarkBkColor, *lpdwAutoMarkFlags, *lpdwAutoMarkFontStyle, MARKID_AUTO))
                    bUpdate=TRUE;
                  SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)wpText);
                }

                //Update edit
                if (bUpdate)
                {
                  UpdateEditAndClones(ei.hWndEdit, UE_DRAWRECT);
                  //UpdateEditAll(UE_DRAWRECT);
                }
              }
              else
              {
                if (UnmarkSelection(lpWindowEdit, MARKID_AUTO))
                {
                  UpdateEditAndClones(ei.hWndEdit, UE_DRAWRECT);
                  //UpdateEditAll(UE_DRAWRECT);
                }
              }
            }
          }
        }
      }
    }
  }
  return FALSE;
}

/*
void PaintRichEditA(HSYNTAXFILE *lpSyntaxFile, HWND hWnd, RECT *rcUpdateRect)
{
  //HighLight RichEdit (AkelPad 3.x.x)
  GETTEXTRANGE gtr;
  CHARRANGE64 cr;
  LOGFONTA lfFont;
  TEXTMETRICA tm;
  RECT rcUpdate=*rcUpdateRect;
  RECT rcEdit;
  RECT rcDraw;
  HDC hDC;
  HRGN hRgn;
  HRGN hRgnOld;
  HFONT hFont;
  HFONT hFontOld;
  int nFirstChar;
  int nLastChar;
  int nFirstCharInUpdateLine;
  int i;

  SendMessage(hWnd, EM_GETRECT, 0, (LPARAM)&rcEdit);
  if (rcUpdate.left < rcEdit.left) rcUpdate.left=rcEdit.left;
  if (rcUpdate.top < rcEdit.top) rcUpdate.top=rcEdit.top;
  if (rcUpdate.right > rcEdit.right) rcUpdate.right=rcEdit.right;
  if (rcUpdate.bottom > rcEdit.bottom) rcUpdate.bottom=rcEdit.bottom;
  rcDraw.left=rcEdit.left;
  rcDraw.top=rcUpdate.top;
  rcDraw.right=rcEdit.right;
  rcDraw.bottom=rcUpdate.bottom;

  if (hDC=GetDC(hWnd))
  {
    HideCaret(hWnd);
    hRgn=CreateRectRgn(rcEdit.left, rcEdit.top, rcEdit.right, rcEdit.bottom);
    hRgnOld=(HRGN)SelectObject(hDC, hRgn);
    SendMessage(hMainWnd, AKD_GETFONTA, (WPARAM)hWnd, (LPARAM)&lfFont);
    hFont=CreateFontIndirectA(&lfFont);
    hFontOld=(HFONT)SelectObject(hDC, hFont);
    GetTextMetricsA(hDC, &tm);
    SetBkMode(hDC, TRANSPARENT);

    i=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&rcDraw.left);
    i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, i);
    nFirstChar=SendMessage(hWnd, EM_LINEINDEX, i, 0);
    i=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&rcDraw.right);
    i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, i);
    i=SendMessage(hWnd, EM_LINEINDEX, i, 0);
    nLastChar=i + SendMessage(hWnd, EM_LINELENGTH, i, 0);
    gtr.cpMin=nFirstChar;
    gtr.cpMax=nLastChar;
    SendMessage(hWnd, EM_EXGETSEL64, 0, (LPARAM)&cr);

    if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWnd, (LPARAM)&gtr))
    {
      DELIMITERINFO *lpDelimElement=NULL;
      WORDINFO *lpWordElement=NULL;
      char szWord[MAX_PATH];
      wchar_t wszWord[MAX_PATH];
      char *szText=(char *)gtr.pText;
      char *pStrBegin;
      char *pStrEnd;
      POINT ptUpdateLine;
      POINT ptDelimiter;
      POINT ptWordBegin;
      POINT ptWordEnd;
      POINT ptSelBegin;
      POINT ptSelEnd;
      int nDelimiterIndex;
      int nWordBeginIndex;
      int nWordEndIndex;
      int nWordLen;

      //Get first visible word
      nFirstCharInUpdateLine=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&rcUpdate);
      if (nFirstCharInUpdateLine > nFirstChar) --nFirstCharInUpdateLine;
      if (nFirstCharInUpdateLine >= nLastChar) goto FreeText;
      pStrEnd=szText + (nFirstCharInUpdateLine - nFirstChar);

      while (pStrEnd > szText && (*pStrEnd != ' ' && *pStrEnd != '\t' && *pStrEnd != '\r' && !StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *pStrEnd)))
        --pStrEnd;
      while (*pStrEnd == ' ' || *pStrEnd == '\t' || *pStrEnd == '\r')
        ++pStrEnd;
      pStrBegin=pStrEnd;

      GetPosFromChar(hWnd, nFirstCharInUpdateLine, &ptUpdateLine, &tm);
      ptUpdateLine.x=rcUpdate.left;

      for (;;)
      {
        lpDelimElement=NULL;

        if (*pStrEnd == ' ' ||
            *pStrEnd == '\t' ||
            *pStrEnd == '\r' ||
            *pStrEnd == '\0' ||
            (lpDelimElement=StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *pStrEnd)))
        {
          ////DELIMITER
          if (lpDelimElement)
          {
            if ((int)lpDelimElement->dwColor2 != -1 || (int)lpDelimElement->dwColor1 != -1)
            {
              nDelimiterIndex=nFirstChar + (pStrEnd - szText);
              GetPosFromChar(hWnd, nDelimiterIndex, &ptDelimiter, &tm);
              if (ptDelimiter.y < ptUpdateLine.y) goto FreeText;

              if (ptDelimiter.y > ptUpdateLine.y ||
                  (pStrBegin == pStrEnd &&
                   ptDelimiter.y == ptUpdateLine.y &&
                   ptDelimiter.x >= rcUpdate.right &&
                   nDelimiterIndex > nFirstCharInUpdateLine))
              {
                ptUpdateLine.y+=tm.tmHeight;

                nFirstCharInUpdateLine=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&ptUpdateLine);
                i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, nFirstCharInUpdateLine);
                i=SendMessage(hWnd, EM_LINEINDEX, i, 0);
                if (nFirstCharInUpdateLine > i) --nFirstCharInUpdateLine;
                if (nFirstCharInUpdateLine >= nLastChar) goto FreeText;
                pStrBegin=szText + (i - nFirstChar);
                pStrEnd=szText + (nFirstCharInUpdateLine - nFirstChar);

                while (pStrEnd > pStrBegin && (*pStrEnd != ' ' && *pStrEnd != '\t' && *pStrEnd != '\r' && !StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *pStrEnd)))
                  --pStrEnd;
                while (*pStrEnd == ' ' || *pStrEnd == '\t' || *pStrEnd == '\r')
                  ++pStrEnd;
                pStrBegin=pStrEnd;
                continue;
              }
              else
              {
                if (ptDelimiter.x + tm.tmMaxCharWidth > rcUpdate.left)
                {
                  rcDraw.left=ptDelimiter.x;
                  rcDraw.top=ptDelimiter.y;

                  if (!(nDelimiterIndex >= cr.cpMin && nDelimiterIndex < cr.cpMax))
                  {
                    if ((int)lpDelimElement->dwColor1 != -1)
                    {
                      SetTextColor(hDC, lpDelimElement->dwColor1);
                      DrawTextA(hDC, pStrEnd, 1, &rcDraw, DT_NOPREFIX);
                    }
                  }
                  else
                  {
                    if ((int)lpDelimElement->dwColor2 != -1)
                    {
                      SetTextColor(hDC, lpDelimElement->dwColor2);
                      DrawTextA(hDC, pStrEnd, 1, &rcDraw, DT_NOPREFIX);
                    }
                  }
                }
              }
            }
          }
          nWordLen=pStrEnd - pStrBegin;

          ////WORD
          if (nWordLen && nWordLen < MAX_PATH)
          {
            nWordBeginIndex=nFirstChar + (pStrBegin - szText);
            nWordEndIndex=nFirstChar + (pStrEnd - szText);
            GetPosFromChar(hWnd, nWordBeginIndex, &ptWordBegin, &tm);
            GetPosFromChar(hWnd, nWordEndIndex, &ptWordEnd, &tm);
            if (ptWordBegin.y < ptUpdateLine.y) goto FreeText;

            if (ptWordBegin.y == ptWordEnd.y)
            {
              if (bOldRichEdit)
              {
                //RichEdit 2.0: make word highlited, even if its beginning is not displayed
                if (ptWordBegin.x > ptWordEnd.x) ptWordBegin.x-=0x10000;
              }
            }

            if (ptWordBegin.y != ptWordEnd.y ||
                ptWordBegin.y > ptUpdateLine.y ||
                (ptWordBegin.y == ptUpdateLine.y &&
                 ptWordBegin.x >= rcUpdate.right &&
                 nWordBeginIndex > nFirstCharInUpdateLine))
            {
              ptUpdateLine.y+=tm.tmHeight;

              nFirstCharInUpdateLine=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&ptUpdateLine);
              i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, nFirstCharInUpdateLine);
              i=SendMessage(hWnd, EM_LINEINDEX, i, 0);
              if (nFirstCharInUpdateLine > i) --nFirstCharInUpdateLine;
              if (nFirstCharInUpdateLine >= nLastChar) goto FreeText;
              pStrBegin=szText + (i - nFirstChar);
              pStrEnd=szText + (nFirstCharInUpdateLine - nFirstChar);

              while (pStrEnd > pStrBegin && (*pStrEnd != ' ' && *pStrEnd != '\t' && *pStrEnd != '\r' && !StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *pStrEnd)))
                --pStrEnd;
              while (*pStrEnd == ' ' || *pStrEnd == '\t' || *pStrEnd == '\r')
                ++pStrEnd;
              pStrBegin=pStrEnd;
              continue;
            }
            else
            {
              if (ptWordEnd.x > rcUpdate.left)
              {
                lstrcpynA(szWord, pStrBegin, nWordLen + 1);
                rcDraw.left=ptWordBegin.x;
                rcDraw.top=ptWordBegin.y;

                MultiByteToWideChar(CP_ACP, 0, szWord, -1, wszWord, MAX_PATH);
                if (lpWordElement=StackGetWord(&lpSyntaxFile->hWordStack, wszWord, nWordLen))
                {
                  if (nWordBeginIndex >= cr.cpMax || nWordEndIndex <= cr.cpMin)
                  {
                    if ((int)lpWordElement->dwColor1 != -1)
                    {
                      SetTextColor(hDC, lpWordElement->dwColor1);
                      DrawTextA(hDC, pStrBegin, nWordLen, &rcDraw, DT_NOPREFIX);
                    }
                  }
                  else
                  {
                    //Highlight selection
                    GetPosFromChar(hWnd, cr.cpMin, &ptSelBegin, &tm);
                    GetPosFromChar(hWnd, cr.cpMax, &ptSelEnd, &tm);

                    if ((int)lpWordElement->dwColor1 != -1)
                    {
                      SetTextColor(hDC, lpWordElement->dwColor1);

                      if (nWordBeginIndex < cr.cpMin)
                      {
                        rcDraw.left=ptWordBegin.x;
                        DrawTextA(hDC, pStrBegin, cr.cpMin - nWordBeginIndex, &rcDraw, DT_NOPREFIX);
                      }
                      if (nWordEndIndex > cr.cpMax)
                      {
                        rcDraw.left=ptSelEnd.x;
                        DrawTextA(hDC, pStrBegin + (cr.cpMax - nWordBeginIndex), nWordEndIndex - cr.cpMax, &rcDraw, DT_NOPREFIX);
                      }
                    }
                    if ((int)lpWordElement->dwColor2 != -1)
                    {
                      if (cr.cpMin > nWordBeginIndex)
                        rcDraw.left=ptSelBegin.x;
                      else
                        rcDraw.left=ptWordBegin.x;
                      SetTextColor(hDC, lpWordElement->dwColor2);
                      DrawTextA(hDC, pStrBegin + (max(cr.cpMin, nWordBeginIndex) - nWordBeginIndex), min(cr.cpMax, nWordEndIndex) - max(cr.cpMin, nWordBeginIndex), &rcDraw, DT_NOPREFIX);
                    }
                  }
                }
              }
            }
          }
          if (!*pStrEnd) break;
          while (*++pStrEnd == ' ' || *pStrEnd == '\t' || *pStrEnd == '\r');
          pStrBegin=pStrEnd;
        }
        else ++pStrEnd;
      }
      FreeText:
      SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
    }
    if (hFontOld) SelectObject(hDC, hFontOld);
    DeleteObject(hFont);
    if (hRgnOld) SelectObject(hDC, hRgnOld);
    DeleteObject(hRgn);
    ShowCaret(hWnd);
    ReleaseDC(hWnd, hDC);
  }
}

void PaintRichEditW(HSYNTAXFILE *lpSyntaxFile, HWND hWnd, RECT *rcUpdateRect)
{
  //HighLight RichEdit (AkelPad 3.x.x)
  GETTEXTRANGE gtr;
  CHARRANGE64 cr;
  LOGFONTW lfFont;
  TEXTMETRICW tm;
  RECT rcUpdate=*rcUpdateRect;
  RECT rcEdit;
  RECT rcDraw;
  HDC hDC;
  HRGN hRgn;
  HRGN hRgnOld;
  HFONT hFont;
  HFONT hFontOld;
  int nFirstChar;
  int nLastChar;
  int nFirstCharInUpdateLine;
  int i;

  SendMessage(hWnd, EM_GETRECT, 0, (LPARAM)&rcEdit);
  if (rcUpdate.left < rcEdit.left) rcUpdate.left=rcEdit.left;
  if (rcUpdate.top < rcEdit.top) rcUpdate.top=rcEdit.top;
  if (rcUpdate.right > rcEdit.right) rcUpdate.right=rcEdit.right;
  if (rcUpdate.bottom > rcEdit.bottom) rcUpdate.bottom=rcEdit.bottom;
  rcDraw.left=rcEdit.left;
  rcDraw.top=rcUpdate.top;
  rcDraw.right=rcEdit.right;
  rcDraw.bottom=rcUpdate.bottom;

  if (hDC=GetDC(hWnd))
  {
    HideCaret(hWnd);
    hRgn=CreateRectRgn(rcEdit.left, rcEdit.top, rcEdit.right, rcEdit.bottom);
    hRgnOld=(HRGN)SelectObject(hDC, hRgn);
    SendMessage(hMainWnd, AKD_GETFONTW, (WPARAM)hWnd, (LPARAM)&lfFont);
    hFont=CreateFontIndirectW(&lfFont);
    hFontOld=(HFONT)SelectObject(hDC, hFont);
    GetTextMetricsW(hDC, &tm);
    SetBkMode(hDC, TRANSPARENT);

    i=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&rcDraw.left);
    i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, i);
    nFirstChar=SendMessage(hWnd, EM_LINEINDEX, i, 0);
    i=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&rcDraw.right);
    i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, i);
    i=SendMessage(hWnd, EM_LINEINDEX, i, 0);
    nLastChar=i + SendMessage(hWnd, EM_LINELENGTH, i, 0);
    gtr.cpMin=nFirstChar;
    gtr.cpMax=nLastChar;
    SendMessage(hWnd, EM_EXGETSEL64, 0, (LPARAM)&cr);

    if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWnd, (LPARAM)&gtr))
    {
      DELIMITERINFO *lpDelimElement=NULL;
      WORDINFO *lpWordElement=NULL;
      wchar_t wszWord[MAX_PATH];
      wchar_t *wszText=(wchar_t *)gtr.pText;
      wchar_t *wpStrBegin;
      wchar_t *wpStrEnd;
      POINT ptUpdateLine;
      POINT ptDelimiter;
      POINT ptWordBegin;
      POINT ptWordEnd;
      POINT ptSelBegin;
      POINT ptSelEnd;
      int nDelimiterIndex;
      int nWordBeginIndex;
      int nWordEndIndex;
      int nWordLen;

      //Get first visible word
      nFirstCharInUpdateLine=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&rcUpdate);
      if (nFirstCharInUpdateLine > nFirstChar) --nFirstCharInUpdateLine;
      if (nFirstCharInUpdateLine >= nLastChar) goto FreeText;
      wpStrEnd=wszText + (nFirstCharInUpdateLine - nFirstChar);

      while (wpStrEnd > wszText && (*wpStrEnd != ' ' && *wpStrEnd != '\t' && *wpStrEnd != '\r' && !StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *wpStrEnd)))
        --wpStrEnd;
      while (*wpStrEnd == ' ' || *wpStrEnd == '\t' || *wpStrEnd == '\r')
        ++wpStrEnd;
      wpStrBegin=wpStrEnd;

      GetPosFromChar(hWnd, nFirstCharInUpdateLine, &ptUpdateLine, (TEXTMETRICA *)&tm);
      ptUpdateLine.x=rcUpdate.left;

      for (;;)
      {
        lpDelimElement=NULL;

        if (*wpStrEnd == ' ' ||
            *wpStrEnd == '\t' ||
            *wpStrEnd == '\r' ||
            *wpStrEnd == '\0' ||
            (lpDelimElement=StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *wpStrEnd)))
        {
          ////DELIMITER
          if (lpDelimElement)
          {
            if ((int)lpDelimElement->dwColor2 != -1 || (int)lpDelimElement->dwColor1 != -1)
            {
              nDelimiterIndex=nFirstChar + (wpStrEnd - wszText);
              GetPosFromChar(hWnd, nDelimiterIndex, &ptDelimiter, (TEXTMETRICA *)&tm);
              if (ptDelimiter.y < ptUpdateLine.y) goto FreeText;

              if (ptDelimiter.y > ptUpdateLine.y ||
                  (wpStrBegin == wpStrEnd &&
                   ptDelimiter.y == ptUpdateLine.y &&
                   ptDelimiter.x >= rcUpdate.right &&
                   nDelimiterIndex > nFirstCharInUpdateLine))
              {
                ptUpdateLine.y+=tm.tmHeight;

                nFirstCharInUpdateLine=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&ptUpdateLine);
                i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, nFirstCharInUpdateLine);
                i=SendMessage(hWnd, EM_LINEINDEX, i, 0);
                if (nFirstCharInUpdateLine > i) --nFirstCharInUpdateLine;
                if (nFirstCharInUpdateLine >= nLastChar) goto FreeText;
                wpStrBegin=wszText + (i - nFirstChar);
                wpStrEnd=wszText + (nFirstCharInUpdateLine - nFirstChar);

                while (wpStrEnd > wpStrBegin && (*wpStrEnd != ' ' && *wpStrEnd != '\t' && *wpStrEnd != '\r' && !StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *wpStrEnd)))
                  --wpStrEnd;
                while (*wpStrEnd == ' ' || *wpStrEnd == '\t' || *wpStrEnd == '\r')
                  ++wpStrEnd;
                wpStrBegin=wpStrEnd;
                continue;
              }
              else
              {
                if (ptDelimiter.x + tm.tmMaxCharWidth > rcUpdate.left)
                {
                  rcDraw.left=ptDelimiter.x;
                  rcDraw.top=ptDelimiter.y;

                  if (!(nDelimiterIndex >= cr.cpMin && nDelimiterIndex < cr.cpMax))
                  {
                    if ((int)lpDelimElement->dwColor1 != -1)
                    {
                      SetTextColor(hDC, lpDelimElement->dwColor1);
                      DrawTextW(hDC, wpStrEnd, 1, &rcDraw, DT_NOPREFIX);
                    }
                  }
                  else
                  {
                    if ((int)lpDelimElement->dwColor2 != -1)
                    {
                      SetTextColor(hDC, lpDelimElement->dwColor2);
                      DrawTextW(hDC, wpStrEnd, 1, &rcDraw, DT_NOPREFIX);
                    }
                  }
                }
              }
            }
          }
          nWordLen=wpStrEnd - wpStrBegin;

          ////WORD
          if (nWordLen && nWordLen < MAX_PATH)
          {
            nWordBeginIndex=nFirstChar + (wpStrBegin - wszText);
            nWordEndIndex=nFirstChar + (wpStrEnd - wszText);
            GetPosFromChar(hWnd, nWordBeginIndex, &ptWordBegin, (TEXTMETRICA *)&tm);
            GetPosFromChar(hWnd, nWordEndIndex, &ptWordEnd, (TEXTMETRICA *)&tm);
            if (ptWordBegin.y < ptUpdateLine.y) goto FreeText;

            if (ptWordBegin.y == ptWordEnd.y)
            {
              if (bOldRichEdit)
              {
                //RichEdit 2.0: make word highlited, even if its beginning is not displayed
                if (ptWordBegin.x > ptWordEnd.x) ptWordBegin.x-=0x10000;
              }
            }

            if (ptWordBegin.y != ptWordEnd.y ||
                ptWordBegin.y > ptUpdateLine.y ||
                (ptWordBegin.y == ptUpdateLine.y &&
                 ptWordBegin.x >= rcUpdate.right &&
                 nWordBeginIndex > nFirstCharInUpdateLine))
            {
              ptUpdateLine.y+=tm.tmHeight;

              nFirstCharInUpdateLine=SendMessage(hWnd, EM_CHARFROMPOS, 0, (LPARAM)&ptUpdateLine);
              i=SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, nFirstCharInUpdateLine);
              i=SendMessage(hWnd, EM_LINEINDEX, i, 0);
              if (nFirstCharInUpdateLine > i) --nFirstCharInUpdateLine;
              if (nFirstCharInUpdateLine >= nLastChar) goto FreeText;
              wpStrBegin=wszText + (i - nFirstChar);
              wpStrEnd=wszText + (nFirstCharInUpdateLine - nFirstChar);

              while (wpStrEnd > wpStrBegin && (*wpStrEnd != ' ' && *wpStrEnd != '\t' && *wpStrEnd != '\r' && !StackGetDelimiter(&lpSyntaxFile->hDelimiterStack, *wpStrEnd)))
                --wpStrEnd;
              while (*wpStrEnd == ' ' || *wpStrEnd == '\t' || *wpStrEnd == '\r')
                ++wpStrEnd;
              wpStrBegin=wpStrEnd;
              continue;
            }
            else
            {
              if (ptWordEnd.x > rcUpdate.left)
              {
                xstrcpynW(wszWord, wpStrBegin, nWordLen + 1);
                rcDraw.left=ptWordBegin.x;
                rcDraw.top=ptWordBegin.y;

                if (lpWordElement=StackGetWord(&lpSyntaxFile->hWordStack, wszWord, nWordLen))
                {
                  if (nWordBeginIndex >= cr.cpMax || nWordEndIndex <= cr.cpMin)
                  {
                    if ((int)lpWordElement->dwColor1 != -1)
                    {
                      SetTextColor(hDC, lpWordElement->dwColor1);
                      DrawTextW(hDC, wpStrBegin, nWordLen, &rcDraw, DT_NOPREFIX);
                    }
                  }
                  else
                  {
                    //Highlight selection
                    GetPosFromChar(hWnd, cr.cpMin, &ptSelBegin, (TEXTMETRICA *)&tm);
                    GetPosFromChar(hWnd, cr.cpMax, &ptSelEnd, (TEXTMETRICA *)&tm);

                    if ((int)lpWordElement->dwColor1 != -1)
                    {
                      SetTextColor(hDC, lpWordElement->dwColor1);

                      if (nWordBeginIndex < cr.cpMin)
                      {
                        rcDraw.left=ptWordBegin.x;
                        DrawTextW(hDC, wpStrBegin, cr.cpMin - nWordBeginIndex, &rcDraw, DT_NOPREFIX);
                      }
                      if (nWordEndIndex > cr.cpMax)
                      {
                        rcDraw.left=ptSelEnd.x;
                        DrawTextW(hDC, wpStrBegin + (cr.cpMax - nWordBeginIndex), nWordEndIndex - cr.cpMax, &rcDraw, DT_NOPREFIX);
                      }
                    }
                    if ((int)lpWordElement->dwColor2 != -1)
                    {
                      if (cr.cpMin > nWordBeginIndex)
                        rcDraw.left=ptSelBegin.x;
                      else
                        rcDraw.left=ptWordBegin.x;
                      SetTextColor(hDC, lpWordElement->dwColor2);
                      DrawTextW(hDC, wpStrBegin + (max(cr.cpMin, nWordBeginIndex) - nWordBeginIndex), min(cr.cpMax, nWordEndIndex) - max(cr.cpMin, nWordBeginIndex), &rcDraw, DT_NOPREFIX);
                    }
                  }
                }
              }
            }
          }
          if (!*wpStrEnd) break;
          while (*++wpStrEnd == ' ' || *wpStrEnd == '\t' || *wpStrEnd == '\r');
          wpStrBegin=wpStrEnd;
        }
        else ++wpStrEnd;
      }
      FreeText:
      SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
    }
    if (hFontOld) SelectObject(hDC, hFontOld);
    DeleteObject(hFont);
    if (hRgnOld) SelectObject(hDC, hRgnOld);
    DeleteObject(hRgn);
    ShowCaret(hWnd);
    ReleaseDC(hWnd, hDC);
  }
}

void GetPosFromChar(HWND hWnd, int nCharIndex, POINT *pt, TEXTMETRICA *tm)
{
  DWORD dwPosition;

  if (bOldRichEdit)
  {
    dwPosition=SendMessage(hWnd, EM_POSFROMCHAR, nCharIndex, (LPARAM)NULL);
    pt->x=LOWORD(dwPosition);
    pt->y=HIWORD(dwPosition);

    if (tm)
    {
      if (pt->x > 0x10000 - tm->tmMaxCharWidth)
        pt->x-=0x10000;
      if (pt->y > 0x10000 - tm->tmHeight)
        pt->y-=0x10000;
    }
  }
  else
  {
    SendMessage(hWnd, EM_POSFROMCHAR, (WPARAM)pt, nCharIndex);
  }
}
*/

WORDINFO* StackInsertWord(HWORDSTACK *hStack, int nWordLen)
{
  WORDINFO *lpElement1;
  WORDINFO *lpElement2=NULL;

  if ((DWORD)nWordLen < sizeof(hStack->lpWordLens) / sizeof(INT_PTR))
  {
    if (hStack->lpWordLens[nWordLen])
    {
      lpElement1=(WORDINFO *)hStack->lpWordLens[nWordLen];
    }
    else
    {
      lpElement1=(WORDINFO *)hStack->first;

      while (lpElement1)
      {
        if (lpElement1->nWordLen >= nWordLen)
          break;

        lpElement1=lpElement1->next;
      }
    }
    StackInsertBefore((stack **)&hStack->first, (stack **)&hStack->last, (stack *)lpElement1, (stack **)&lpElement2, sizeof(WORDINFO));

    if (lpElement2)
      hStack->lpWordLens[nWordLen]=(INT_PTR)lpElement2;
  }
  return lpElement2;
}

WORDINFO* StackGetWord(HWORDSTACK *hStack, wchar_t *wpWord, int nWordLen)
{
  WORDINFO *lpElement=NULL;

  if ((DWORD)nWordLen < sizeof(hStack->lpWordLens) / sizeof(INT_PTR))
  {
    lpElement=(WORDINFO *)hStack->lpWordLens[nWordLen];

    while (lpElement)
    {
      if (lpElement->nWordLen != nWordLen)
        break;
      if (lpElement->dwFlags & AEHLF_MATCHCASE)
      {
        if (!xstrcmpW(lpElement->wpWord, wpWord))
          return lpElement;
      }
      else
      {
        if (!xstrcmpiW(lpElement->wpWord, wpWord))
          return lpElement;
      }
      lpElement=lpElement->next;
    }
  }
  return NULL;
}

void StackFreeWord(HWORDSTACK *hStack)
{
  WORDINFO *lpElement=(WORDINFO *)hStack->first;

  while (lpElement)
  {
    GlobalFree((HGLOBAL)lpElement->wpWord);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hStack->first, (stack **)&hStack->last);
  xmemset(hStack->lpWordLens, 0, sizeof(hStack->lpWordLens));
}

QUOTEINFO* StackInsertQuote(HQUOTESTACK *hStack, int nQuoteStartLen)
{
  QUOTEINFO *lpElement=NULL;

  StackInsertIndex((stack **)&hStack->first, (stack **)&hStack->last, (stack **)&lpElement, -1, sizeof(QUOTEINFO));
  return lpElement;
}

void StackFreeQuote(HQUOTESTACK *hStack)
{
  QUOTEINFO *lpElement=(QUOTEINFO *)hStack->first;

  while (lpElement)
  {
    GlobalFree((HGLOBAL)lpElement->wpQuoteStart);
    GlobalFree((HGLOBAL)lpElement->wpQuoteEnd);
    GlobalFree((HGLOBAL)lpElement->wpQuoteInclude);
    GlobalFree((HGLOBAL)lpElement->wpQuoteExclude);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hStack->first, (stack **)&hStack->last);
}

HWINDOWEDIT* StackInsertHighLightWindow(HSTACK *hStack)
{
  HWINDOWEDIT *lpElement=NULL;

  StackInsertIndex((stack **)&hStack->first, (stack **)&hStack->last, (stack **)&lpElement, -1, sizeof(HWINDOWEDIT));

  return lpElement;
}

HWINDOWEDIT* StackGetHighLightWindow(HSTACK *hStack, HWND hWndMaster, AEHDOC hDocMaster)
{
  HWINDOWEDIT *lpElement=(HWINDOWEDIT *)hStack->first;

  if (nMDI == WMD_PMDI)
  {
    while (lpElement)
    {
      if (lpElement->hDocEdit == hDocMaster)
        return lpElement;

      lpElement=lpElement->next;
    }
  }
  else
  {
    while (lpElement)
    {
      if (lpElement->hWndEdit == hWndMaster)
        return lpElement;

      lpElement=lpElement->next;
    }
  }
  return NULL;
}

void StackDeleteHighLightWindow(HSTACK *hStack, HWINDOWEDIT *lpWindowEdit)
{
  FRAMEDATA *lpFrameToActivate=NULL;
  FRAMEDATA *lpFrameToRestore=NULL;

  if (nMDI == WMD_PMDI)
  {
    //In WMD_PMDI mode to work with non-active frame we should activate it first.
    lpFrameToActivate=(FRAMEDATA *)SendMessage(hMainWnd, AKD_FRAMEFINDW, FWF_BYEDITDOCUMENT, (LPARAM)lpWindowEdit->hDocEdit);
    lpFrameToRestore=(FRAMEDATA *)SendMessage(hMainWnd, AKD_FRAMEACTIVATE, FWA_NOVISUPDATE, (LPARAM)lpFrameToActivate);
    if (lpFrameToRestore == lpFrameToActivate)
      lpFrameToRestore=NULL;
  }

  UnmarkSelection(lpWindowEdit, 0);
  RestoreFontAndColors(lpWindowEdit);
  UnassignTheme(lpWindowEdit->hWndEdit);
  StackDelete((stack **)&hStack->first, (stack **)&hStack->last, (stack *)lpWindowEdit);

  if (nMDI == WMD_PMDI)
  {
    if (lpFrameToRestore)
    {
      SendMessage(hMainWnd, AKD_FRAMEACTIVATE, FWA_NOVISUPDATE, (LPARAM)lpFrameToRestore);
      lpFrameToRestore=NULL;
    }
  }
}

void StackFreeHighLightWindow(HSTACK *hStack)
{
  HWINDOWEDIT *lpElement=(HWINDOWEDIT *)hStack->first;
  HWINDOWEDIT *lpNextElement;

  while (lpElement)
  {
    lpNextElement=lpElement->next;
    StackDeleteHighLightWindow(hStack, lpElement);
    lpElement=lpNextElement;
  }
}

MARKTEXT* StackInsertMarkText(HWINDOWEDIT *lpWindowEdit)
{
  MARKTEXT *lpMarkText=NULL;

  StackInsertIndex((stack **)&lpWindowEdit->hMarkTextsStack.first, (stack **)&lpWindowEdit->hMarkTextsStack.last, (stack **)&lpMarkText, -1, sizeof(MARKTEXT));
  return lpMarkText;
}

MARKTEXT* StackGetMarkText(HWINDOWEDIT *lpWindowEdit, DWORD dwMarkID)
{
  MARKTEXT *lpMarkText=(MARKTEXT *)lpWindowEdit->hMarkTextsStack.first;

  while (lpMarkText)
  {
    if (lpMarkText->dwMarkID == dwMarkID)
      return lpMarkText;

    lpMarkText=lpMarkText->next;
  }
  return NULL;
}

BOOL StackIsAnyMarkText(HWINDOWEDIT *lpWindowEdit)
{
  if (lpWindowEdit->hMarkTextsStack.first)
    return TRUE;
  return FALSE;
}

void StackDeleteMarkText(HWINDOWEDIT *lpWindowEdit, MARKTEXT *lpMarkText)
{
  SendMessage(lpWindowEdit->hWndEdit, AEM_HLDELETEMARKTEXT, (WPARAM)NULL, (LPARAM)lpMarkText->hMarkTextHandle);
  StackDelete((stack **)&lpWindowEdit->hMarkTextsStack.first, (stack **)&lpWindowEdit->hMarkTextsStack.last, (stack *)lpMarkText);
}

void StackFreeMarkText(HWINDOWEDIT *lpWindowEdit)
{
  MARKTEXT *lpMarkText=(MARKTEXT *)lpWindowEdit->hMarkTextsStack.first;
  MARKTEXT *lpNextMarkText;

  while (lpMarkText)
  {
    lpNextMarkText=lpMarkText->next;

    StackDeleteMarkText(lpWindowEdit, lpMarkText);

    lpMarkText=lpNextMarkText;
  }
}

BOOL MarkSelection(HWINDOWEDIT *lpWindowEdit, const wchar_t *wpText, int nTextLen, DWORD dwColorText, DWORD dwColorBk, BOOL bMatchCase, DWORD dwFontStyle, DWORD dwMarkID)
{
  BOOL bResult=FALSE;

  if (dwMarkID)
  {
    AEMARKTEXTITEMW mti;
    AEHMARKTEXT hMarkTextHandle;
    MARKTEXT *lpMarkText;

    if (lpMarkText=StackGetMarkText(lpWindowEdit, dwMarkID))
      StackDeleteMarkText(lpWindowEdit, lpMarkText);

    mti.nIndex=1;
    mti.pMarkText=wpText;
    mti.nMarkTextLen=nTextLen;
    mti.dwFlags=bMatchCase?AEHLF_MATCHCASE:0;
    mti.crText=dwColorText;
    mti.crBk=dwColorBk;
    mti.dwFontStyle=dwFontStyle;

    if (hMarkTextHandle=(AEHMARKTEXT)SendMessage(lpWindowEdit->hWndEdit, AEM_HLADDMARKTEXTW, (WPARAM)NULL, (LPARAM)&mti))
    {
      if (lpMarkText=StackInsertMarkText(lpWindowEdit))
      {
        lpMarkText->hMarkTextHandle=hMarkTextHandle;
        lpMarkText->dwMarkID=dwMarkID;

        bResult=TRUE;
      }
    }
  }
  return bResult;
}

BOOL UnmarkSelection(HWINDOWEDIT *lpWindowEdit, DWORD dwMarkID)
{
  MARKTEXT *lpMarkText=NULL;
  BOOL bResult=TRUE;

  if (dwMarkID)
  {
    if (lpMarkText=StackGetMarkText(lpWindowEdit, dwMarkID))
      StackDeleteMarkText(lpWindowEdit, lpMarkText);
    else
      bResult=FALSE;
  }
  else StackFreeMarkText(lpWindowEdit);

  return bResult;
}

void CreateEditTheme(HSYNTAXFILE *lpSyntaxFile, HWND hWnd)
{
  AEDELIMITEMW di;
  AEWORDITEMW wi;
  AEQUOTEITEMW qi;

  xprintfW(wszBuffer, L"HighLight::File::%s", lpSyntaxFile->wszSyntaxFileName);

  if (lpSyntaxFile->hThemeHighLight=(HANDLE)SendMessage(hWnd, AEM_HLCREATETHEMEW, 0, (LPARAM)wszBuffer))
  {
    //Transfer delimiters
    {
      DELIMITERINFO *lpElement=(DELIMITERINFO *)lpSyntaxFile->hDelimiterStack.first;

      while (lpElement)
      {
        di.nIndex=-1;
        di.pDelimiter=lpElement->wpDelimiter;
        di.nDelimiterLen=lpElement->nDelimiterLen;
        di.dwFlags=lpElement->dwFlags;
        di.crText=lpElement->dwColor1;
        di.crBk=lpElement->dwColor2;
        di.dwFontStyle=GetFontStyle(lpElement->dwFontStyle);
        SendMessage(hWnd, AEM_HLADDDELIMITERW, (WPARAM)lpSyntaxFile->hThemeHighLight, (LPARAM)&di);

        lpElement=lpElement->next;
      }
    }

    //Transfer words
    {
      WORDINFO *lpElement=(WORDINFO *)lpSyntaxFile->hWordStack.last;

      while (lpElement)
      {
        wi.pWord=lpElement->wpWord;
        wi.nWordLen=lpElement->nWordLen;
        wi.dwFlags=lpElement->dwFlags;
        wi.crText=lpElement->dwColor1;
        wi.crBk=lpElement->dwColor2;
        wi.dwFontStyle=GetFontStyle(lpElement->dwFontStyle);
        SendMessage(hWnd, AEM_HLADDWORDW, (WPARAM)lpSyntaxFile->hThemeHighLight, (LPARAM)&wi);

        lpElement=lpElement->prev;
      }
    }

    //Transfer quotes
    {
      QUOTEINFO *lpElement=(QUOTEINFO *)lpSyntaxFile->hQuoteStack.first;

      while (lpElement)
      {
        qi.nIndex=-1;
        qi.pQuoteStart=lpElement->wpQuoteStart;
        qi.nQuoteStartLen=lpElement->nQuoteStartLen;
        qi.pQuoteEnd=lpElement->wpQuoteEnd;
        qi.nQuoteEndLen=lpElement->nQuoteEndLen;
        qi.chEscape=lpElement->wchEscape;
        qi.pQuoteInclude=lpElement->wpQuoteInclude;
        qi.nQuoteIncludeLen=lpElement->nQuoteIncludeLen;
        qi.pQuoteExclude=lpElement->wpQuoteExclude;
        qi.nQuoteExcludeLen=lpElement->nQuoteExcludeLen;
        qi.dwFlags=lpElement->dwFlags;
        qi.crText=lpElement->dwColor1;
        qi.crBk=lpElement->dwColor2;
        qi.dwFontStyle=GetFontStyle(lpElement->dwFontStyle);

        if (qi.nQuoteIncludeLen)
          qi.dwFlags|=AEHLF_QUOTEINCLUDE;
        if (qi.nQuoteExcludeLen)
          qi.dwFlags|=AEHLF_QUOTEEXCLUDE;
        SendMessage(hWnd, AEM_HLADDQUOTEW, (WPARAM)lpSyntaxFile->hThemeHighLight, (LPARAM)&qi);

        lpElement=lpElement->next;
      }
    }
  }
}

void GetFontAndColors(HSYNTAXFILE *lpSyntaxFile, HWINDOWEDIT *lpWindowEdit)
{
  if (!lpWindowEdit->bOldColors)
  {
    lpWindowEdit->bOldColors=TRUE;
    lpWindowEdit->aecNew.dwFlags=lpSyntaxFile->aecColors.dwFlags;

    if (lpWindowEdit->aecNew.dwFlags)
    {
      //Current AECOLORS
      SendMessage(hMainWnd, AKD_GETCOLORS, (WPARAM)lpWindowEdit->hWndEdit, (LPARAM)&lpWindowEdit->aecOld);
      //lpWindowEdit->aecOld.dwFlags=AECLR_ALL;

      //New AECOLORS
      xmemcpy(&lpWindowEdit->aecNew, &lpSyntaxFile->aecColors, sizeof(AECOLORS));
    }
  }
  if (!lpWindowEdit->bOldFont)
  {
    lpWindowEdit->bOldFont=TRUE;
    lpWindowEdit->dwFontFlags=lpSyntaxFile->dwFontFlags;

    if (lpWindowEdit->dwFontFlags)
    {
      HFONT hFontOld;

      hFontOld=(HFONT)SendMessage(lpWindowEdit->hWndEdit, WM_GETFONT, 0, 0);

      //Current LOGFONTW
      if (bOldWindows)
      {
        LOGFONTA lfA;

        GetObjectA(hFontOld, sizeof(LOGFONTA), &lfA);
        LogFontAtoW(&lfA, &lpWindowEdit->lfFontOld);
      }
      else GetObjectW(hFontOld, sizeof(LOGFONTW), &lpWindowEdit->lfFontOld);

      //New LOGFONTW
      xmemcpy(&lpWindowEdit->lfFontNew, &lpSyntaxFile->lfFont, sizeof(LOGFONTW));

      if (!(lpWindowEdit->dwFontFlags & FF_FONTSTYLE))
      {
        lpWindowEdit->lfFontNew.lfWeight=lpWindowEdit->lfFontOld.lfWeight;
        lpWindowEdit->lfFontNew.lfItalic=lpWindowEdit->lfFontOld.lfItalic;
      }
      if (!(lpWindowEdit->dwFontFlags & FF_FONTSIZE))
      {
        lpWindowEdit->lfFontNew.lfHeight=-mod(lpWindowEdit->lfFontOld.lfHeight);
      }
      if (!(lpWindowEdit->dwFontFlags & FF_FONTFACE))
      {
        xstrcpynW(lpWindowEdit->lfFontNew.lfFaceName, lpWindowEdit->lfFontOld.lfFaceName, LF_FACESIZE);
      }
    }
  }
}

void RestoreFontAndColors(HWINDOWEDIT *lpWindowEdit)
{
  DWORD dwLockInherit=(DWORD)-1;

  if (lpWindowEdit->bOldColors)
  {
    lpWindowEdit->bOldColors=FALSE;

    if (lpWindowEdit->aecNew.dwFlags)
    {
      if (dwLockInherit == (DWORD)-1)
        dwLockInherit=(DWORD)SendMessage(hMainWnd, AKD_GETLOCKINHERIT, (WPARAM)lpWindowEdit->hWndEdit, 0);

      if (dwLockInherit != (DWORD)-1)
      {
        if (dwLockInherit & LI_COLORS)
        {
          lpWindowEdit->aecOld.dwFlags=GetColorsToRestore(lpWindowEdit->hWndEdit, &lpWindowEdit->aecNew);
          SendMessage(hMainWnd, AKD_SETCOLORS, (WPARAM)lpWindowEdit->hWndEdit, (LPARAM)&lpWindowEdit->aecOld);
        }
      }
    }
  }
  if (lpWindowEdit->bOldFont)
  {
    lpWindowEdit->bOldFont=FALSE;

    if (lpWindowEdit->dwFontFlags)
    {
      if (dwLockInherit == (DWORD)-1)
        dwLockInherit=(DWORD)SendMessage(hMainWnd, AKD_GETLOCKINHERIT, (WPARAM)lpWindowEdit->hWndEdit, 0);

      if (dwLockInherit != (DWORD)-1)
      {
        if (dwLockInherit & LI_FONT)
        {
          SendMessage(hMainWnd, AKD_SETFONTW, (WPARAM)lpWindowEdit->hWndEdit, (LPARAM)&lpWindowEdit->lfFontOld);
        }
      }
    }
  }
}

void UnassignTheme(HWND hWnd)
{
  HANDLE hThemeHighLight;
  wchar_t wszThemeName[MAX_PATH];

  if (hThemeHighLight=(HANDLE)SendMessage(hWnd, AEM_HLGETTHEMEW, 0, (LPARAM)NULL))
  {
    if (SendMessage(hWnd, AEM_HLGETTHEMENAMEW, (WPARAM)hThemeHighLight, (LPARAM)wszThemeName))
    {
      if (!xstrcmpnW(L"HighLight::File::", wszThemeName, (UINT_PTR)-1))
      {
        SendMessage(hWnd, AEM_HLSETTHEME, (WPARAM)NULL, FALSE);
      }
    }
  }
}

DWORD GetFontStyle(DWORD dwFontStyle)
{
  if (dwFontStyle != AEHLS_NONE)
  {
    if (dwFontStyle == AEHLS_FONTNORMAL)
    {
      if (dwIgnoreFontStyle & IFS_FONTNORMAL)
        return AEHLS_NONE;
    }
    else if (dwFontStyle == AEHLS_FONTBOLD)
    {
      if (dwIgnoreFontStyle & IFS_FONTBOLD)
        return AEHLS_NONE;
    }
    else if (dwFontStyle == AEHLS_FONTITALIC)
    {
      if (dwIgnoreFontStyle & IFS_FONTITALIC)
        return AEHLS_NONE;
    }
    else if (dwFontStyle == AEHLS_FONTBOLDITALIC)
    {
      if (dwIgnoreFontStyle & IFS_FONTBOLDITALIC)
        return AEHLS_NONE;
    }
  }
  return dwFontStyle;
}

DWORD GetColorsToRestore(HWND hWnd, AECOLORS *aecHighlight)
{
  AECOLORS aecCurrent;
  DWORD dwFlags=aecHighlight->dwFlags;

  //Get current colors
  SendMessage(hMainWnd, AKD_GETCOLORS, (WPARAM)hWnd, (LPARAM)&aecCurrent);

  //Get changed colors
  if (dwFlags & AECLR_CARET)
  {
    if (aecHighlight->crCaret != aecCurrent.crCaret)
      dwFlags&=~AECLR_CARET;
  }
  if (dwFlags & AECLR_BASICTEXT)
  {
    if (aecHighlight->crBasicText != aecCurrent.crBasicText)
      dwFlags&=~AECLR_BASICTEXT;
  }
  if (dwFlags & AECLR_BASICBK)
  {
    if (aecHighlight->crBasicBk != aecCurrent.crBasicBk)
      dwFlags&=~AECLR_BASICBK;
  }
  if (dwFlags & AECLR_SELTEXT)
  {
    if (aecHighlight->crSelText != aecCurrent.crSelText)
      dwFlags&=~AECLR_SELTEXT;
  }
  if (dwFlags & AECLR_SELBK)
  {
    if (aecHighlight->crSelBk != aecCurrent.crSelBk)
      dwFlags&=~AECLR_SELBK;
  }
  if (dwFlags & AECLR_ACTIVELINETEXT)
  {
    if (aecHighlight->crActiveLineText != aecCurrent.crActiveLineText)
      dwFlags&=~AECLR_ACTIVELINETEXT;
  }
  if (dwFlags & AECLR_ACTIVELINEBK)
  {
    if (aecHighlight->crActiveLineBk != aecCurrent.crActiveLineBk)
      dwFlags&=~AECLR_ACTIVELINEBK;
  }
  if (dwFlags & AECLR_URLTEXT)
  {
    if (aecHighlight->crUrlText != aecCurrent.crUrlText)
      dwFlags&=~AECLR_URLTEXT;
  }
  if (dwFlags & AECLR_ACTIVECOLUMN)
  {
    if (aecHighlight->crActiveColumn != aecCurrent.crActiveColumn)
      dwFlags&=~AECLR_ACTIVECOLUMN;
  }
  if (dwFlags & AECLR_COLUMNMARKER)
  {
    if (aecHighlight->crColumnMarker != aecCurrent.crColumnMarker)
      dwFlags&=~AECLR_COLUMNMARKER;
  }
  return dwFlags;
}

COLORREF GetColorValueFromStrA(char *pColor)
{
  COLORREF crColor;

  crColor=(COLORREF)hex2decA(pColor);
  crColor=RGB(GetBValue(crColor), GetGValue(crColor), GetRValue(crColor));
  return crColor;
}

COLORREF GetColorValueFromStrW(wchar_t *wpColor)
{
  COLORREF crColor;

  crColor=(COLORREF)hex2decW(wpColor);
  crColor=RGB(GetBValue(crColor), GetGValue(crColor), GetRValue(crColor));
  return crColor;
}

char* GetColorStrFromValueA(COLORREF crColor, char *szColor)
{
  wsprintfA(szColor, "%02X%02X%02X", GetRValue(crColor), GetGValue(crColor), GetBValue(crColor));
  return szColor;
}

wchar_t* GetColorStrFromValueW(COLORREF crColor, wchar_t *wszColor)
{
  xprintfW(wszColor, L"%02X%02X%02X", GetRValue(crColor), GetGValue(crColor), GetBValue(crColor));
  return wszColor;
}


//// Options

void ReadHighLightOptions(HANDLE hOptions)
{
  WideOption(hOptions, L"IgnoreFontStyle", PO_DWORD, (LPBYTE)&dwIgnoreFontStyle, sizeof(DWORD));
  WideOption(hOptions, L"AutoMarkEnable", PO_DWORD, (LPBYTE)&bAutoMarkEnable, sizeof(DWORD));
  WideOption(hOptions, L"AutoMarkType", PO_DWORD, (LPBYTE)&nAutoMarkType, sizeof(DWORD));
}

void SaveHighLightOptions(HANDLE hOptions, DWORD dwFlags)
{
  if (dwFlags & OF_HIGHLIGHT_SETTINGS)
  {
    WideOption(hOptions, L"IgnoreFontStyle", PO_DWORD, (LPBYTE)&dwIgnoreFontStyle, sizeof(DWORD));
    WideOption(hOptions, L"AutoMarkEnable", PO_DWORD, (LPBYTE)&bAutoMarkEnable, sizeof(DWORD));
    WideOption(hOptions, L"AutoMarkType", PO_DWORD, (LPBYTE)&nAutoMarkType, sizeof(DWORD));
  }
}

void InitHighLight()
{
  bInitHighLight=TRUE;
}

void UninitHighLight()
{
  bInitHighLight=FALSE;

  StackFreeHighLightWindow(&hHighLightWindowsStack);
}
