#define WIN32_LEAN_AND_MEAN
#define _WIN32_IE 0x0500
#include <windows.h>
#include <commctrl.h>
#include <richedit.h>
#include "AkelEdit.h"
#include "AkelDLL.h"
#include "StackFunc.h"
#include "StrFunc.h"
#include "WideFunc.h"
#include "Resources\Resource.h"


//Include stack functions
#define StackGetElement
#define StackInsertAfter
#define StackInsertBefore
#define StackInsertIndex
#define StackDelete
#define StackClear
#define StackSize
#include "StackFunc.h"

//Include string functions
#define WideCharLower
#define xmemcpy
#define xmemset
#define xmemcmp
#define xstrcmpW
#define xstrcmpiW
#define xstrlenW
#define xstrcpyW
#define xstrcpynW
#define xatoiW
#define xitoaW
#define xuitoaW
#define dec2hexW
#define hex2decW
#define xprintfW
#include "StrFunc.h"

//Include wide functions
#define CreateProcessWide
#define CreateWindowExWide
#define DispatchMessageWide
#define ExpandEnvironmentStringsWide
#define ExtractIconExWide
#define GetMenuStringWide
#define GetMessageWide
#define GetWindowLongPtrWide
#define InsertMenuWide
#define IsDialogMessageWide
#define RegisterClassWide
#define SearchPathWide
#define SetDlgItemTextWide
#define SetWindowLongPtrWide
#define SetWindowTextWide
#define TranslateAcceleratorWide
#define UnregisterClassWide
#include "WideFunc.h"

//Defines
#define STRID_SETUP       1
#define STRID_AUTOLOAD    2
#define STRID_BIGICONS    3
#define STRID_FLATBUTTONS 4
#define STRID_16BIT       5
#define STRID_32BIT       6
#define STRID_SIDE        7
#define STRID_PLUGIN      8
#define STRID_OK          9
#define STRID_CANCEL      10

#define AKDLL_RECREATE    (WM_USER + 1)
#define AKDLL_REFRESH     (WM_USER + 2)
#define AKDLL_SETUP       (WM_USER + 3)
#define AKDLL_SELTEXT     (WM_USER + 4)

#define OF_LISTTEXT       0x1
#define OF_SETTINGS       0x2
#define OF_RECT           0x4

#define BUFFER_SIZE       1024

#define EXTACT_COMMAND    1
#define EXTACT_CALL       2
#define EXTACT_EXEC       3
#define EXTACT_OPENFILE   4
#define EXTACT_SAVEFILE   5
#define EXTACT_FONT       6
#define EXTACT_RECODE     7
#define EXTACT_INSERT     8

#define EXTPARAM_CHAR     1
#define EXTPARAM_INT      2

#define FS_NONE            0
#define FS_FONTNORMAL      1
#define FS_FONTBOLD        2
#define FS_FONTITALIC      3
#define FS_FONTBOLDITALIC  4

#define MAX_TOOLBARTEXT_SIZE  64000

//Toolbar side
#define TBSIDE_LEFT    1
#define TBSIDE_RIGHT   2
#define TBSIDE_TOP     3
#define TBSIDE_BOTTOM  4

#define IMENU_EDIT     0x00000001
#define IMENU_CHECKS   0x00000004

#define TOOLBARBACKGROUNDA   "ToolbarBG"
#define TOOLBARBACKGROUNDW  L"ToolbarBG"

#define TXT_DEFAULT_PART1W L"\
# New document\r\
\"\" Command(4101) Icon(0)\r\
\r\
# New instance\r\
# \"\" Command(4102) Icon(1)\r\
\r\
# Open\r\
\"\" Command(4103) Icon(2)\r\
\r\
# Reload\r\
# \"\" Command(4104) Icon(3)\r\
\r\
# SEPARATOR\r\
\r\
# Save\r\
\"\" Command(4105) Icon(4)\r\
\r\
# Save as\r\
# \"\" Command(4106) Icon(5)\r\
\r\
# Save all\r\
#\"\" Command(4110) Icon(32)\r\
\r\
# Save all as\r\
#\"\" Command(4111) Icon(33)\r\
\r\
SEPARATOR\r\
\r\
# Print\r\
\"\" Command(4108) Icon(6)\r\
\r\
# Print preview\r\
\"\" Command(4114) Icon(21)\r\
\r\
SEPARATOR\r\
\r\
# Cut\r\
\"\" Command(4153) Icon(7)\r\
\r\
# Copy\r\
\"\" Command(4154) Icon(8)\r\
\r\
# Paste\r\
\"\" Command(4155) Icon(9)\r\
\r\
# Delete\r\
\"\" Command(4156) Icon(25)\r\
\r\
SEPARATOR\r\
\r\
# Undo\r\
\"\" Command(4151) Icon(10)\r\
\r\
# Redo\r\
\"\" Command(4152) Icon(11)\r\
\r\
SEPARATOR\r\
\r\
# Find\r\
\"\" Command(4158) Icon(12)\r\
\r\
# Replace\r\
\"\" Command(4161) Icon(13)\r\
\r\
# Insert char\r\
# \"\" Command(4163) Icon(14)\r\
\r\
# Insert date\r\
# \"\" Command(4183) Icon(26)\r"

#define TXT_DEFAULT_PART2W L"\
\r\
# SEPARATOR\r\
\r\
# Font\r\
# \"\" Command(4201) Icon(27)\r\
\r\
# Font increase\r\
# -\"\" Command(4204) Icon(28)\r\
\r\
# Font decrease\r\
# -\"\" Command(4205) Icon(29)\r\
\r\
# Colors\r\
# \"\" Command(4202) Icon(30)\r\
\r\
SEPARATOR\r\
\r\
# Read-only\r\
\"\" Command(4216) Icon(20)\r\
\r\
# Word wrap\r\
\"\" Command(4209) Icon(16)\r\
\r\
# Split all\r\
# -\"\" Command(4212) Icon(22)\r\
\r\
# Split vertical\r\
# -\"\" Command(4213) Icon(23)\r\
\r\
# Split horizontal\r\
# -\"\" Command(4214) Icon(24)\r\
\r\
# On top\r\
\"\" Command(4210) Icon(15)\r\
\r\
# Execute\r\
# \"\" Command(4251) Icon(17)\r\
\r\
SEPARATOR\r\
\r\
# Plugins\r\
\"\" Command(4259) Icon(18)\r\
\r\
# Settings\r\
\"\" Command(4260) Icon(19)\r"

#define TXT_DEFAULT_PART3W L"\
\r\
# SEPARATOR\r\
\r\
# -\"Macros plugin\" Call(\"Macros::Main\") Icon(\"%a\\AkelFiles\\Plugs\\Macros.dll\", 0)\r\
\r\
# -\"Record macro\" Call(\"Macros::Main\", 2, \"%m\", \"%i\") Icon(\"%a\\AkelFiles\\Plugs\\Macros.dll\", 1)\r\
\r\
# -\"Play macro once\" Call(\"Macros::Main\", 1, \"\", 1) Icon(\"%a\\AkelFiles\\Plugs\\Macros.dll\", 3)\r\
\r\
# -\"Play macro to end\" Call(\"Macros::Main\", 3, \"%m\", \"%i\") Icon(\"%a\\AkelFiles\\Plugs\\Macros.dll\", 4)\r"

#define TXT_DEFAULT_PART4W L"\
\r\
# SEPARATOR\r\
\r\
# \"HighLight\" +Call(\"Coder::HighLight\") Icon(\"%a\\AkelFiles\\Plugs\\Coder.dll\", 0)\r\
\r\
# \"CodeFold\" +Call(\"Coder::CodeFold\") Icon(\"%a\\AkelFiles\\Plugs\\Coder.dll\", 1)\r\
\r\
# -\"CodeFold list show/hide\" Call(\"Coder::CodeFold\", 1) Icon(\"%a\\AkelFiles\\Plugs\\Coder.dll\", 3)\r\
\r\
# \"AutoComplete\" +Call(\"Coder::AutoComplete\") Icon(\"%a\\AkelFiles\\Plugs\\Coder.dll\", 2)\r\
\r\
# \"SpecialChar plugin\" +Call(\"SpecialChar::Main\") Icon(\"%a\\AkelFiles\\Plugs\\SpecialChar.dll\", 0)\r\
\r\
# \"LineBoard plugin\" +Call(\"LineBoard::Main\") Icon(\"%a\\AkelFiles\\Plugs\\LineBoard.dll\", 0)\r\
\r\
# \"Explorer plugin\" +Call(\"Explorer::Main\") Icon(\"%a\\AkelFiles\\Plugs\\Explorer.dll\", 0)\r\
\r\
# -\"Hotkeys plugin\" +Call(\"Hotkeys::Main\") Icon(\"%a\\AkelFiles\\Plugs\\Hotkeys.dll\", 0)\r\
\r\
# \"Run Notepad\" Exec(\"notepad.exe\") Icon(\"notepad.exe\")\r"

typedef struct _EXTPARAM {
  struct _EXTPARAM *next;
  struct _EXTPARAM *prev;
  DWORD dwType;
  int nNumber;
  char *pString;
  wchar_t *wpString;
  char *pExpanded;
  wchar_t *wpExpanded;
} EXTPARAM;

typedef struct {
  EXTPARAM *first;
  EXTPARAM *last;
  int nElements;
} STACKEXTPARAM;

typedef struct _TOOLBARDATA {
  HSTACK hButtonsStack;
  HIMAGELIST hImageList;
} TOOLBARDATA;

typedef struct _TOOLBARITEM {
  struct _TOOLBARITEM *next;
  struct _TOOLBARITEM *prev;
  TBBUTTON tbb;
  wchar_t wszButtonItem[MAX_PATH];
  int nTextOffset;
  BOOL bUpdateItem;
  BOOL bAutoLoad;
  DWORD dwAction;
  STACKEXTPARAM hParamStack;
} TOOLBARITEM;

typedef struct _PLUGINCALL {
  unsigned char *lpStruct;
  BOOL bAutoLoad;
} PLUGINCALL;

//Functions prototypes
BOOL CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewEditDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
DWORD WINAPI ThreadProc(LPVOID lpParameter);
LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void CALLBACK NewMainProcRet(CWPRETSTRUCT *cwprs);
LRESULT CALLBACK ToolbarBGProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewToolbarProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

void CreateToolbarWindow();
void CreateToolbarData(TOOLBARDATA *hToolbarData, const wchar_t *wpText);
void FreeToolbarData(TOOLBARDATA *hToolbarData);
void SetToolbarButtons(TOOLBARDATA *hToolbarData);
void ClearToolbarButtons();
void UpdateToolbar(HSTACK *hStack);
void CallToolbar(HSTACK *hStack, int nItem);
void DestroyToolbarWindow(BOOL bDestroyBG);
TOOLBARITEM* StackInsertButton(HSTACK *hStack);
TOOLBARITEM* StackGetButtonByID(HSTACK *hStack, int nItemID);
TOOLBARITEM* StackGetButtonByIndex(HSTACK *hStack, int nIndex);
void StackFreeButton(HSTACK *hStack);

void ParseMethodParameters(STACKEXTPARAM *hParamStack, const wchar_t *wpText, const wchar_t **wppText);
void ExpandMethodParameters(STACKEXTPARAM *hParamStack, const wchar_t *wpFile, const wchar_t *wpExeDir, const wchar_t *wpToolbarID, const wchar_t *wpItemID);
int StructMethodParameters(STACKEXTPARAM *hParamStack, unsigned char **lppStruct);
EXTPARAM* GetMethodParameter(STACKEXTPARAM *hParamStack, int nIndex);
void GetIconParameters(const wchar_t *wpText, wchar_t *wszIconFile, int nMaxIconFile, int *nIconIndex, const wchar_t **wppText);
void FreeMethodParameters(STACKEXTPARAM *hParamStack);
int GetMethodName(const wchar_t *wpText, wchar_t *wszStr, int nStrLen, const wchar_t **wppText);
int NextString(const wchar_t *wpText, wchar_t *wszStr, int nStrLen, const wchar_t **wppText, int *nMinus);
BOOL SkipComment(const wchar_t **wpText);
int GetFileDir(const wchar_t *wpFile, wchar_t *wszFileDir, int nFileDirLen);
INT_PTR TranslateEscapeString(HWND hWndEdit, const wchar_t *wpInput, wchar_t *wszOutput, DWORD *lpdwCaret);
int TranslateFileString(const wchar_t *wpString, wchar_t *wszBuffer, int nBufferSize);

int GetCurFile(wchar_t *wszFile, int nMaxFile);
INT_PTR GetEditText(HWND hWnd, wchar_t **Text);
void ShowStandardEditMenu(HWND hWnd, HMENU hMenu, BOOL bMouse);
DWORD ScrollCaret(HWND hWnd);

void ReadOptions(DWORD dwFlags);
void SaveOptions(DWORD dwFlags);
const char* GetLangStringA(LANGID wLangID, int nStringID);
const wchar_t* GetLangStringW(LANGID wLangID, int nStringID);
void InitCommon(PLUGINDATA *pd);
void InitMain();
void UninitMain();

//Global variables
wchar_t wszBuffer[BUFFER_SIZE];
wchar_t wszPluginName[MAX_PATH];
HANDLE hHeap;
HINSTANCE hInstanceEXE;
HINSTANCE hInstanceDLL;
HWND hMainWnd;
HWND hMdiClient;
HMENU hMainMenu;
HMENU hMenuRecentFiles;
HMENU hPopupEdit;
HICON hMainIcon;
HACCEL hGlobalAccel;
BOOL bOldWindows;
BOOL bAkelEdit;
int nMDI;
LANGID wLangModule;
BOOL bInitCommon=FALSE;
BOOL bInitMain=FALSE;
DWORD dwSaveFlags=0;
char szExeDir[MAX_PATH];
wchar_t wszExeDir[MAX_PATH];
char *szToolBarText=NULL;
wchar_t *wszToolBarText=NULL;
TOOLBARDATA hToolbarStack;
HWND hToolbarBG=NULL;
HWND hToolbar=NULL;
BOOL bBigIcons=FALSE;
BOOL bFlatButtons=TRUE;
int nIconsBit=32;
int nToolbarSide=TBSIDE_TOP;
SIZE sizeToolbar={0};
SIZE sizeButtons={0};
CHARRANGE64 crExtSetSel={0};
HANDLE hThread=NULL;
DWORD dwThreadId;
HWND hWndMainDlg=NULL;
RECT rcMainMinMaxDialog={473, 174, 0, 0};
RECT rcMainCurrentDialog={0};
WNDPROC OldToolbarProc=NULL;
WNDPROC OldEditDlgProc=NULL;
WNDPROCDATA *NewMainProcData=NULL;
WNDPROCRETDATA *NewMainProcRetData=NULL;
WNDPROCRETDATA *NewFrameProcRetData=NULL;


//Identification
void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(-1, -1, -1, -1);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 6, 2, 0);
  pv->pPluginName="ToolBar";
}

//Plugin extern function
void __declspec(dllexport) Main(PLUGINDATA *pd)
{
  pd->dwSupport|=PDS_SUPPORTALL;
  if (pd->dwSupport & PDS_GETSUPPORT)
    return;

  if (!bInitCommon) InitCommon(pd);

  //Is plugin already loaded?
  if (bInitMain)
  {
    UninitMain();

    SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
  }
  else
  {
    InitMain();

    if (!pd->bOnStart)
    {
      CreateToolbarWindow();
      SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
    }

    //Stay in memory, and show as active
    pd->nUnload=UD_NONUNLOAD_ACTIVE;
  }
}

BOOL CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndToolBarText;
  static HWND hWndBigIconsCheck;
  static HWND hWndFlatButtonsCheck;
  static HWND hWndBit16;
  static HWND hWndBit32;
  static HWND hWndSideLeft;
  static HWND hWndSideTop;
  static HWND hWndSideRight;
  static HWND hWndSideBottom;
  static HWND hWndSideLabel;
  static HWND hWndOK;
  static HWND hWndCancel;
  static DIALOGRESIZE drs[]={{&hWndToolBarText,      DRS_SIZE|DRS_X, 0},
                             {&hWndToolBarText,      DRS_SIZE|DRS_Y, 0},
                             {&hWndBigIconsCheck,    DRS_MOVE|DRS_Y, 0},
                             {&hWndFlatButtonsCheck, DRS_MOVE|DRS_Y, 0},
                             {&hWndBit16,            DRS_MOVE|DRS_Y, 0},
                             {&hWndBit32,            DRS_MOVE|DRS_Y, 0},
                             {&hWndSideLeft,         DRS_MOVE|DRS_Y, 0},
                             {&hWndSideTop,          DRS_MOVE|DRS_Y, 0},
                             {&hWndSideRight,        DRS_MOVE|DRS_Y, 0},
                             {&hWndSideBottom,       DRS_MOVE|DRS_Y, 0},
                             {&hWndSideLabel,        DRS_MOVE|DRS_Y, 0},
                             {&hWndOK,               DRS_MOVE|DRS_X, 0},
                             {&hWndOK,               DRS_MOVE|DRS_Y, 0},
                             {&hWndCancel,           DRS_MOVE|DRS_X, 0},
                             {&hWndCancel,           DRS_MOVE|DRS_Y, 0},
                             {0, 0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndToolBarText=GetDlgItem(hDlg, IDC_TOOLBARTEXT);
    hWndBigIconsCheck=GetDlgItem(hDlg, IDC_BIGICONS);
    hWndFlatButtonsCheck=GetDlgItem(hDlg, IDC_FLATBUTTONS);
    hWndBit16=GetDlgItem(hDlg, IDC_16BIT);
    hWndBit32=GetDlgItem(hDlg, IDC_32BIT);
    hWndSideLeft=GetDlgItem(hDlg, IDC_SIDELEFT);
    hWndSideTop=GetDlgItem(hDlg, IDC_SIDETOP);
    hWndSideRight=GetDlgItem(hDlg, IDC_SIDERIGHT);
    hWndSideBottom=GetDlgItem(hDlg, IDC_SIDEBOTTOM);
    hWndSideLabel=GetDlgItem(hDlg, IDC_SIDE_LABEL);
    hWndOK=GetDlgItem(hDlg, IDOK);
    hWndCancel=GetDlgItem(hDlg, IDCANCEL);

    xprintfW(wszBuffer, GetLangStringW(wLangModule, STRID_PLUGIN), wszPluginName);
    SetWindowTextWide(hDlg, wszBuffer);
    SetDlgItemTextWide(hDlg, IDC_BIGICONS, GetLangStringW(wLangModule, STRID_BIGICONS));
    SetDlgItemTextWide(hDlg, IDC_FLATBUTTONS, GetLangStringW(wLangModule, STRID_FLATBUTTONS));
    SetDlgItemTextWide(hDlg, IDC_16BIT, GetLangStringW(wLangModule, STRID_16BIT));
    SetDlgItemTextWide(hDlg, IDC_32BIT, GetLangStringW(wLangModule, STRID_32BIT));
    SetDlgItemTextWide(hDlg, IDC_SIDE_LABEL, GetLangStringW(wLangModule, STRID_SIDE));
    SetDlgItemTextWide(hDlg, IDOK, GetLangStringW(wLangModule, STRID_OK));
    SetDlgItemTextWide(hDlg, IDCANCEL, GetLangStringW(wLangModule, STRID_CANCEL));

    SendMessage(hWndToolBarText, EM_SETTEXTMODE, TM_PLAINTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
    SendMessage(hWndToolBarText, EM_EXLIMITTEXT, 0, MAX_TOOLBARTEXT_SIZE);
    SetWindowTextWide(hWndToolBarText, wszToolBarText);

    if (bBigIcons)
      SendMessage(hWndBigIconsCheck, BM_SETCHECK, BST_CHECKED, 0);
    if (bFlatButtons)
      SendMessage(hWndFlatButtonsCheck, BM_SETCHECK, BST_CHECKED, 0);
    if (nIconsBit == 16)
      SendMessage(hWndBit16, BM_SETCHECK, BST_CHECKED, 0);
    else
      SendMessage(hWndBit32, BM_SETCHECK, BST_CHECKED, 0);

    if (nToolbarSide == TBSIDE_LEFT)
      SendMessage(hWndSideLeft, BM_SETCHECK, BST_CHECKED, 0);
    else if (nToolbarSide == TBSIDE_TOP)
      SendMessage(hWndSideTop, BM_SETCHECK, BST_CHECKED, 0);
    else if (nToolbarSide == TBSIDE_RIGHT)
      SendMessage(hWndSideRight, BM_SETCHECK, BST_CHECKED, 0);
    else if (nToolbarSide == TBSIDE_BOTTOM)
      SendMessage(hWndSideBottom, BM_SETCHECK, BST_CHECKED, 0);

    OldEditDlgProc=(WNDPROC)GetWindowLongPtrWide(hWndToolBarText, GWLP_WNDPROC);
    SetWindowLongPtrWide(hWndToolBarText, GWLP_WNDPROC, (UINT_PTR)NewEditDlgProc);

    //Post AKDLL_SELTEXT because dialog size can be changed after AKD_DIALOGRESIZE
    PostMessage(hDlg, AKDLL_SELTEXT, 0, 0);
  }
  else if (uMsg == AKDLL_SELTEXT)
  {
    if (crExtSetSel.cpMin || crExtSetSel.cpMax)
    {
      int nLine;
      int nLockScroll;

      if (crExtSetSel.cpMax == -1)
      {
        nLine=(int)SendMessage(hWndToolBarText, EM_EXLINEFROMCHAR, 0, crExtSetSel.cpMin);
        crExtSetSel.cpMax=SendMessage(hWndToolBarText, EM_LINEINDEX, nLine, 0) + SendMessage(hWndToolBarText, EM_LINELENGTH, crExtSetSel.cpMin, 0);
      }

      if (bAkelEdit)
      {
        if ((nLockScroll=(int)SendMessage(hWndToolBarText, AEM_LOCKSCROLL, (WPARAM)-1, 0)) == -1)
          SendMessage(hWndToolBarText, AEM_LOCKSCROLL, SB_BOTH, TRUE);
      }
      SendMessage(hWndToolBarText, EM_SETSEL, crExtSetSel.cpMax, crExtSetSel.cpMin);
      if (bAkelEdit && nLockScroll == -1)
      {
        SendMessage(hWndToolBarText, AEM_LOCKSCROLL, SB_BOTH, FALSE);
        ScrollCaret(hWndToolBarText);
      }
      crExtSetSel.cpMin=0;
      crExtSetSel.cpMax=0;
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
    {
      if (LOWORD(wParam) == IDOK)
      {
        int nValue;
        BOOL bUpdate=FALSE;

        //Big icons
        if (SendMessage(hWndBigIconsCheck, BM_GETCHECK, 0, 0) != bBigIcons)
        {
          bBigIcons=!bBigIcons;
          bUpdate=TRUE;
        }

        //Flat buttons
        if (SendMessage(hWndFlatButtonsCheck, BM_GETCHECK, 0, 0) != bFlatButtons)
        {
          bFlatButtons=!bFlatButtons;

          nValue=(int)SendMessage(hToolbar, TB_GETSTYLE, 0, 0);
          if (bFlatButtons)
            SendMessage(hToolbar, TB_SETSTYLE, 0, nValue | TBSTYLE_FLAT);
          else
            SendMessage(hToolbar, TB_SETSTYLE, 0, nValue & ~TBSTYLE_FLAT);

          InvalidateRect(hToolbar, NULL, TRUE);
        }

        //Icons bit
        if (SendMessage(hWndBit16, BM_GETCHECK, 0, 0) == BST_CHECKED)
          nValue=16;
        else
          nValue=32;
        if (nIconsBit != nValue)
        {
          nIconsBit=nValue;
          bUpdate=TRUE;
        }

        //Toolbar side
        if (SendMessage(hWndSideLeft, BM_GETCHECK, 0, 0) == BST_CHECKED)
          nValue=TBSIDE_LEFT;
        else if (SendMessage(hWndSideTop, BM_GETCHECK, 0, 0) == BST_CHECKED)
          nValue=TBSIDE_TOP;
        else if (SendMessage(hWndSideRight, BM_GETCHECK, 0, 0) == BST_CHECKED)
          nValue=TBSIDE_RIGHT;
        else if (SendMessage(hWndSideBottom, BM_GETCHECK, 0, 0) == BST_CHECKED)
          nValue=TBSIDE_BOTTOM;
        if (nToolbarSide != nValue)
        {
          nToolbarSide=nValue;
          bUpdate=TRUE;
        }

        if (SendMessage(hWndToolBarText, EM_GETMODIFY, 0, 0))
        {
          if (wszToolBarText)
          {
            HeapFree(hHeap, 0, wszToolBarText);
            wszToolBarText=NULL;
          }
          if (GetEditText(hWndToolBarText, &wszToolBarText))
            bUpdate=TRUE;
        }
        dwSaveFlags|=OF_LISTTEXT|OF_SETTINGS;

        if (bUpdate)
          PostMessage(hToolbarBG, AKDLL_RECREATE, 0, 0);
      }
      if (dwSaveFlags)
      {
        SaveOptions(dwSaveFlags);
        dwSaveFlags=0;
      }

      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      CloseHandle(hThread);
      hThread=NULL;
      ExitThread(0);
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  //Dialog resize messages
  {
    DIALOGRESIZEMSG drsm={&drs[0], &rcMainMinMaxDialog, &rcMainCurrentDialog, DRM_PAINTSIZEGRIP, hDlg, uMsg, wParam, lParam};

    if (SendMessage(hMainWnd, AKD_DIALOGRESIZE, 0, (LPARAM)&drsm))
      dwSaveFlags|=OF_RECT;
  }

  return FALSE;
}

LRESULT CALLBACK NewEditDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (uMsg == WM_GETDLGCODE)
  {
    if (bOldWindows)
      lResult=CallWindowProcA(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
    else
      lResult=CallWindowProcW(OldEditDlgProc, hWnd, uMsg, wParam, lParam);

    if (lResult & DLGC_HASSETSEL)
    {
      lResult&=~DLGC_HASSETSEL;
    }
    return lResult;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    ShowStandardEditMenu((HWND)wParam, hPopupEdit, lParam != -1);
  }

  if (bOldWindows)
    return CallWindowProcA(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
  else
    return CallWindowProcW(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
}

DWORD WINAPI ThreadProc(LPVOID lpParameter)
{
  MSG msg;

  OleInitialize(NULL);

  if (bOldWindows)
    hWndMainDlg=CreateDialogA(hInstanceDLL, MAKEINTRESOURCEA(IDD_SETUPA), hMainWnd, (DLGPROC)MainDlgProc);
  else
    hWndMainDlg=CreateDialogW(hInstanceDLL, MAKEINTRESOURCEW(IDD_SETUPW), hMainWnd, (DLGPROC)MainDlgProc);

  if (hWndMainDlg)
  {
    while (GetMessageWide(&msg, NULL, 0, 0) > 0)
    {
      if (TranslateAcceleratorWide(hMainWnd, hGlobalAccel, &msg))
        continue;

      if (hWndMainDlg && !IsDialogMessageWide(hWndMainDlg, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessageWide(&msg);
      }
    }
  }
  return 0;
}

LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_MAIN_ONSTART_PRESHOW)
  {
    CreateToolbarWindow();
  }
  else if (uMsg == AKDN_SIZE)
  {
    NSIZE *ns=(NSIZE *)lParam;

    if (hToolbarBG && hToolbar && IsWindowVisible(hToolbar))
    {
      if (nToolbarSide == TBSIDE_LEFT)
      {
        MoveWindow(hToolbarBG, ns->rcCurrent.left, ns->rcCurrent.top, sizeToolbar.cx, ns->rcCurrent.bottom, TRUE);
        MoveWindow(hToolbar, sizeToolbar.cx / 2 - sizeButtons.cx / 2, 0, sizeButtons.cx, ns->rcCurrent.bottom, TRUE);
        ns->rcCurrent.left+=sizeToolbar.cx;
        ns->rcCurrent.right-=sizeToolbar.cx;
      }
      else if (nToolbarSide == TBSIDE_TOP)
      {
        MoveWindow(hToolbarBG, ns->rcCurrent.left, ns->rcCurrent.top, ns->rcCurrent.right, sizeToolbar.cy, TRUE);
        MoveWindow(hToolbar, 0, 0, ns->rcCurrent.right, sizeToolbar.cy, TRUE);
        ns->rcCurrent.top+=sizeToolbar.cy;
        ns->rcCurrent.bottom-=sizeToolbar.cy;
      }
      else if (nToolbarSide == TBSIDE_RIGHT)
      {
        MoveWindow(hToolbarBG, ns->rcCurrent.left + ns->rcCurrent.right - sizeToolbar.cx, ns->rcCurrent.top, sizeToolbar.cx, ns->rcCurrent.bottom, TRUE);
        MoveWindow(hToolbar, sizeToolbar.cx / 2 - sizeButtons.cx / 2, 0, sizeButtons.cx, ns->rcCurrent.bottom, TRUE);
        ns->rcCurrent.right-=sizeToolbar.cx;
      }
      else if (nToolbarSide == TBSIDE_BOTTOM)
      {
        MoveWindow(hToolbarBG, ns->rcCurrent.left, ns->rcCurrent.top + ns->rcCurrent.bottom - sizeToolbar.cy, ns->rcCurrent.right, sizeToolbar.cy, TRUE);
        MoveWindow(hToolbar, 0, sizeToolbar.cy - sizeButtons.cy, ns->rcCurrent.right, sizeButtons.cy, TRUE);
        ns->rcCurrent.bottom-=sizeToolbar.cy;
      }
    }
  }
  else if (uMsg == AKDN_MAIN_ONFINISH)
  {
    NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
    if (hWndMainDlg) SendMessage(hWndMainDlg, WM_COMMAND, IDCANCEL, 0);
    UninitMain();
    return FALSE;
  }

  //Call next procedure
  return NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

void CALLBACK NewMainProcRet(CWPRETSTRUCT *cwprs)
{
  if (cwprs->message == AKDN_DLLCALL ||
      cwprs->message == AKDN_DLLUNLOAD ||
      cwprs->message == AKDN_FRAME_NOWINDOWS ||
      (cwprs->message == AKDN_FRAME_ACTIVATE && !(cwprs->wParam & FWA_NOVISUPDATE)))
  {
    PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
  }
  else if (cwprs->message == WM_COMMAND)
  {
    if (cwprs->hwnd == hMainWnd)
    {
      PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
    }
  }
  else if (cwprs->message == WM_NOTIFY)
  {
    if (cwprs->wParam == ID_EDIT)
    {
      if (bAkelEdit)
      {
        if (((NMHDR *)cwprs->lParam)->code == AEN_MODIFY)
        {
          PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
        }
      }
      if (((NMHDR *)cwprs->lParam)->code == EN_SELCHANGE)
      {
        PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
      }
    }

    if (!bAkelEdit)
    {
      if (cwprs->wParam == ID_STATUS)
      {
        if (((NMHDR *)cwprs->lParam)->code == (UINT)NM_DBLCLK)
        {
          if (((NMMOUSE *)cwprs->lParam)->dwItemSpec == 3)
          {
            PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
          }
        }
      }
    }
  }

  //Call next procedure
  if (cwprs->hwnd == hMainWnd)
  {
    if (NewMainProcRetData->NextProc)
      NewMainProcRetData->NextProc(cwprs);
  }
  else
  {
    if (NewFrameProcRetData->NextProc)
      NewFrameProcRetData->NextProc(cwprs);
  }
}

LRESULT CALLBACK ToolbarBGProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDLL_RECREATE)
  {
    DestroyToolbarWindow(FALSE);
    CreateToolbarWindow();
    SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
  }
  else if (uMsg == AKDLL_REFRESH)
  {
    if (hToolbar) UpdateToolbar(&hToolbarStack.hButtonsStack);
  }
  else if (uMsg == AKDLL_SETUP)
  {
    if (!hThread)
    {
      hThread=CreateThread(NULL, 0, ThreadProc, NULL, 0, &dwThreadId);
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    TOOLBARITEM *lpButton;
    POINT pt;
    int nIndex;

    if (lParam == -1)
    {
      pt.x=0;
      pt.y=0;
    }
    else GetCursorPos(&pt);

    //Find mouse over item
    ScreenToClient(hToolbar, &pt);
    nIndex=(int)SendMessage(hToolbar, TB_HITTEST, 0, (LPARAM)&pt);
    if (nIndex < 0) nIndex=(0 - nIndex) - 1;

    if (lpButton=StackGetButtonByIndex(&hToolbarStack.hButtonsStack, nIndex))
    {
      crExtSetSel.cpMin=lpButton->nTextOffset;
      crExtSetSel.cpMax=-1;
    }
    PostMessage(hToolbarBG, AKDLL_SETUP, 0, 0);
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == TTN_GETDISPINFOA)
    {
      TOOLBARITEM *lpButton;

      if (lpButton=StackGetButtonByID(&hToolbarStack.hButtonsStack, (int)((NMHDR *)lParam)->idFrom))
      {
        WideCharToMultiByte(CP_ACP, 0, lpButton->wszButtonItem, -1, ((NMTTDISPINFOA *)lParam)->szText, 80, NULL, NULL);
      }
    }
    else if (((NMHDR *)lParam)->code == TTN_GETDISPINFOW)
    {
      TOOLBARITEM *lpButton;

      if (lpButton=StackGetButtonByID(&hToolbarStack.hButtonsStack, (int)((NMHDR *)lParam)->idFrom))
      {
        xstrcpynW(((NMTTDISPINFOW *)lParam)->szText, lpButton->wszButtonItem, 80);
      }
    }
    else if (((NMHDR *)lParam)->code == TBN_DROPDOWN)
    {
      RECT rc;

      SendMessage(hToolbar, TB_GETRECT, ((NMTOOLBARA *)lParam)->iItem, (LPARAM)&rc);
      ClientToScreen(hToolbar, (LPPOINT)&rc.left);
      ClientToScreen(hToolbar, (LPPOINT)&rc.right);
      TrackPopupMenu(hMenuRecentFiles, TPM_LEFTBUTTON, rc.left, rc.bottom, 0, hMainWnd, NULL);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if ((HWND)lParam == hToolbar)
    {
      CallToolbar(&hToolbarStack.hButtonsStack, LOWORD(wParam));
      return TRUE;
    }
  }

  if (bOldWindows)
    return DefWindowProcA(hWnd, uMsg, wParam, lParam);
  else
    return DefWindowProcW(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewToolbarProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_LBUTTONDBLCLK)
  {
    POINT pt={LOWORD(lParam), HIWORD(lParam)};

    if (SendMessage(hToolbar, TB_HITTEST, 0, (LPARAM)&pt) < 0)
    {
      PostMessage(hToolbarBG, AKDLL_SETUP, 0, 0);
    }
  }
  if (bOldWindows)
    return CallWindowProcA(OldToolbarProc, hWnd, uMsg, wParam, lParam);
  else
    return CallWindowProcW(OldToolbarProc, hWnd, uMsg, wParam, lParam);
}

void CreateToolbarWindow()
{
  WNDCLASSW wndclass;
  DWORD dwStyle=0;

  CreateToolbarData(&hToolbarStack, wszToolBarText);

  if (!hToolbarBG)
  {
    wndclass.style        =CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wndclass.lpfnWndProc  =ToolbarBGProc;
    wndclass.cbClsExtra   =0;
    wndclass.cbWndExtra   =DLGWINDOWEXTRA;
    wndclass.hInstance    =hInstanceDLL;
    wndclass.hIcon        =NULL;
    wndclass.hCursor      =LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground=(HBRUSH)(UINT_PTR)(COLOR_BTNFACE + 1);
    wndclass.lpszMenuName =NULL;
    wndclass.lpszClassName=TOOLBARBACKGROUNDW;
    if (!RegisterClassWide(&wndclass)) return;

    hToolbarBG=CreateWindowExWide(0,
                          TOOLBARBACKGROUNDW,
                          NULL,
                          WS_CHILD|WS_VISIBLE,
                          0, 0, 0, 0,
                          hMainWnd,
                          NULL,
                          hInstanceDLL,
                          NULL);
  }

  if (nToolbarSide == TBSIDE_LEFT)
    dwStyle=CCS_VERT|CCS_NODIVIDER|CCS_NOPARENTALIGN;
  else if (nToolbarSide == TBSIDE_TOP)
    dwStyle=CCS_TOP;
  else if (nToolbarSide == TBSIDE_RIGHT)
    dwStyle=CCS_VERT|CCS_NODIVIDER|CCS_NOPARENTALIGN;
  else if (nToolbarSide == TBSIDE_BOTTOM)
    dwStyle=CCS_NODIVIDER|CCS_NOPARENTALIGN;

  hToolbar=CreateWindowExWide(0,
                        L"ToolbarWindow32",
                        NULL,
                        WS_CHILD|WS_VISIBLE|TBSTYLE_TOOLTIPS|TBSTYLE_TRANSPARENT|
                        (bFlatButtons?TBSTYLE_FLAT:0)|dwStyle,
                        0, 0, 0, 0,
                        hToolbarBG,
                        (HMENU)(UINT_PTR)IDC_TOOLBAR,
                        hInstanceDLL,
                        NULL);

  OldToolbarProc=(WNDPROC)GetWindowLongPtrWide(hToolbar, GWLP_WNDPROC);
  SetWindowLongPtrWide(hToolbar, GWLP_WNDPROC, (UINT_PTR)NewToolbarProc);

  dwStyle=(DWORD)SendMessage(hToolbar, TB_GETEXTENDEDSTYLE, 0, 0);
  SendMessage(hToolbar, TB_SETEXTENDEDSTYLE, 0, dwStyle|TBSTYLE_EX_DRAWDDARROWS);
  SendMessage(hToolbar, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);

  SetToolbarButtons(&hToolbarStack);
  UpdateToolbar(&hToolbarStack.hButtonsStack);
}

void CreateToolbarData(TOOLBARDATA *hToolbarData, const wchar_t *wpText)
{
  TOOLBARITEM *lpElement=NULL;
  EXTPARAM *lpParameter;
  wchar_t wszButtonItem[MAX_PATH];
  wchar_t wszMethodName[MAX_PATH];
  wchar_t wszIconFile[MAX_PATH];
  const wchar_t *wpTextBegin=wpText;
  const wchar_t *wpLineBegin;
  SIZE sizeIcon;
  DWORD dwAction;
  int nPlus;
  int nMinus;
  int nIconIndex;
  int nItemBitmap=0;
  int nItemCommand=0;

  if (wpText)
  {
    if (bBigIcons)
    {
      sizeIcon.cx=32;
      sizeIcon.cy=32;
    }
    else
    {
      sizeIcon.cx=16;
      sizeIcon.cy=16;
    }
    hToolbarData->hImageList=ImageList_Create(sizeIcon.cx, sizeIcon.cy, (nIconsBit == 16?ILC_COLOR16:ILC_COLOR32)|ILC_MASK, 0, 0);
    ImageList_SetBkColor(hToolbarData->hImageList, GetSysColor(COLOR_BTNFACE));

    while (*wpText)
    {
      if (!SkipComment(&wpText)) break;
      wpLineBegin=wpText;
      NextString(wpText, wszButtonItem, MAX_PATH, &wpText, &nMinus);

      while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r' || *wpText == '\n') ++wpText;

      if (!xstrcmpW(wszButtonItem, L"SEPARATOR"))
      {
        if (lpElement=StackInsertButton(&hToolbarData->hButtonsStack))
        {
          lpElement->tbb.iBitmap=-1;
          lpElement->tbb.idCommand=0;
          lpElement->tbb.fsState=0;
          lpElement->tbb.fsStyle=TBSTYLE_SEP;
          lpElement->tbb.dwData=0;
          lpElement->tbb.iString=0;
          lpElement->nTextOffset=(int)(wpLineBegin - wpTextBegin);
        }
      }
      else
      {
        if (*wpText == '+')
        {
          ++wpText;
          nPlus=1;
        }
        else nPlus=0;

        dwAction=0;
        GetMethodName(wpText, wszMethodName, MAX_PATH, &wpText);

        if (!xstrcmpiW(wszMethodName, L"Command"))
          dwAction=EXTACT_COMMAND;
        else if (!xstrcmpiW(wszMethodName, L"Call"))
          dwAction=EXTACT_CALL;
        else if (!xstrcmpiW(wszMethodName, L"Exec"))
          dwAction=EXTACT_EXEC;
        else if (!xstrcmpiW(wszMethodName, L"OpenFile"))
          dwAction=EXTACT_OPENFILE;
        else if (!xstrcmpiW(wszMethodName, L"SaveFile"))
          dwAction=EXTACT_SAVEFILE;
        else if (!xstrcmpiW(wszMethodName, L"Font"))
          dwAction=EXTACT_FONT;
        else if (!xstrcmpiW(wszMethodName, L"Recode"))
          dwAction=EXTACT_RECODE;
        else if (!xstrcmpiW(wszMethodName, L"Insert"))
          dwAction=EXTACT_INSERT;

        if (dwAction)
        {
          if (lpElement=StackInsertButton(&hToolbarData->hButtonsStack))
          {
            lpElement->tbb.iBitmap=-1;
            lpElement->tbb.idCommand=++nItemCommand;
            lpElement->tbb.fsState=TBSTATE_ENABLED;
            lpElement->tbb.fsStyle=TBSTYLE_BUTTON;
            lpElement->tbb.dwData=0;
            lpElement->tbb.iString=0;

            xstrcpynW(lpElement->wszButtonItem, wszButtonItem, MAX_PATH);
            lpElement->nTextOffset=(int)(wpLineBegin - wpTextBegin);
            lpElement->bUpdateItem=!nMinus;
            lpElement->bAutoLoad=nPlus;
            lpElement->dwAction=dwAction;
            ParseMethodParameters(&lpElement->hParamStack, wpText, &wpText);

            if (dwAction == EXTACT_COMMAND)
            {
              int nCommand=0;

              if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
                nCommand=lpParameter->nNumber;

              if (nCommand == IDM_FILE_OPEN)
              {
                lpElement->tbb.fsStyle|=TBSTYLE_DROPDOWN;
              }
              if (!*lpElement->wszButtonItem)
              {
                GetMenuStringWide(hMainMenu, nCommand, lpElement->wszButtonItem, MAX_PATH, MF_BYCOMMAND);
              }
            }
          }
          else break;
        }

        //Icon()
        GetMethodName(wpText, wszMethodName, MAX_PATH, &wpText);

        if (!xstrcmpiW(wszMethodName, L"Icon"))
        {
          HICON hIcon=NULL;

          GetIconParameters(wpText, wszIconFile, MAX_PATH, &nIconIndex, &wpText);

          if (!*wszIconFile)
          {
            hIcon=(HICON)LoadImageA(hInstanceDLL, MAKEINTRESOURCEA(nIconIndex + 100), IMAGE_ICON, sizeIcon.cx, sizeIcon.cy, 0);

            if (hIcon)
            {
              ImageList_AddIcon(hToolbarData->hImageList, hIcon);
              DestroyIcon(hIcon);
            }
          }
          else
          {
            wchar_t wszPath[MAX_PATH];
            wchar_t *wpFileName;
            int nExtracted;

            if (TranslateFileString(wszIconFile, wszPath, MAX_PATH))
            {
              if (SearchPathWide(NULL, wszPath, NULL, MAX_PATH, wszIconFile, &wpFileName))
              {
                if (bBigIcons)
                  nExtracted=ExtractIconExWide(wszPath, nIconIndex, &hIcon, NULL, 1);
                else
                  nExtracted=ExtractIconExWide(wszPath, nIconIndex, NULL, &hIcon, 1);

                if (nExtracted)
                {
                  ImageList_AddIcon(hToolbarData->hImageList, hIcon);
                  DestroyIcon(hIcon);
                }
              }
            }
          }
          if (hIcon) lpElement->tbb.iBitmap=nItemBitmap++;
        }
      }
    }
  }
}

void FreeToolbarData(TOOLBARDATA *hToolbarData)
{
  StackFreeButton(&hToolbarData->hButtonsStack);
  ImageList_Destroy(hToolbarData->hImageList);
}

void SetToolbarButtons(TOOLBARDATA *hToolbarData)
{
  TOOLBARITEM *lpElement=(TOOLBARITEM *)hToolbarData->hButtonsStack.first;

  if (bBigIcons)
  {
    sizeButtons.cx=40;
    sizeButtons.cy=38;
    sizeToolbar.cx=44;
    sizeToolbar.cy=44;
    SendMessage(hToolbar, TB_SETBITMAPSIZE, 0, MAKELONG(32, 32));
    SendMessage(hToolbar, TB_SETBUTTONSIZE, 0, MAKELONG(40, 38));
  }
  else
  {
    sizeButtons.cx=24;
    sizeButtons.cy=22;
    sizeToolbar.cx=28;
    sizeToolbar.cy=28;
    SendMessage(hToolbar, TB_SETBITMAPSIZE, 0, MAKELONG(16, 16));
    SendMessage(hToolbar, TB_SETBUTTONSIZE, 0, MAKELONG(24, 22));
  }
  SendMessage(hToolbar, TB_SETIMAGELIST, 0, (LPARAM)hToolbarData->hImageList);

  while (lpElement)
  {
    if (nToolbarSide == TBSIDE_LEFT || nToolbarSide == TBSIDE_RIGHT)
      lpElement->tbb.fsState|=TBSTATE_WRAP;
    else
      lpElement->tbb.fsState&=~TBSTATE_WRAP;
    SendMessage(hToolbar, TB_ADDBUTTONS, 1, (LPARAM)&lpElement->tbb);

    lpElement=lpElement->next;
  }
}

void ClearToolbarButtons()
{
  while (SendMessage(hToolbar, TB_DELETEBUTTON, 0, 0));
}

void UpdateToolbar(HSTACK *hStack)
{
  TOOLBARITEM *lpElement=(TOOLBARITEM *)hStack->first;
  EXTPARAM *lpParameter;
  BOOL bInitMenu=FALSE;

  while (lpElement)
  {
    if (lpElement->bUpdateItem)
    {
      if (lpElement->dwAction == EXTACT_COMMAND)
      {
        DWORD dwMenuState;
        DWORD dwToolState;
        int nCommand=0;

        if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
          nCommand=lpParameter->nNumber;

        if (nCommand)
        {
          if (!bInitMenu)
          {
            SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);
            bInitMenu=TRUE;
          }

          dwMenuState=GetMenuState(hMainMenu, nCommand, MF_BYCOMMAND);
          dwToolState=(DWORD)SendMessage(hToolbar, TB_GETSTATE, lpElement->tbb.idCommand, 0);

          if (!(dwMenuState & MF_GRAYED) == !(dwToolState & TBSTATE_ENABLED))
            SendMessage(hToolbar, TB_ENABLEBUTTON, lpElement->tbb.idCommand, (dwMenuState & MF_GRAYED)?FALSE:TRUE);
          if (!(dwMenuState & MF_CHECKED) != !(dwToolState & TBSTATE_CHECKED))
            SendMessage(hToolbar, TB_CHECKBUTTON, lpElement->tbb.idCommand, (dwMenuState & MF_CHECKED)?TRUE:FALSE);
        }
      }
      else if (lpElement->dwAction == EXTACT_CALL)
      {
        PLUGINFUNCTION *pf;
        wchar_t *wpFunction=NULL;
        BOOL bChecked;

        if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
          wpFunction=lpParameter->wpString;

        if (wpFunction)
        {
          bChecked=FALSE;
          if (pf=(PLUGINFUNCTION *)SendMessage(hMainWnd, AKD_DLLFINDW, (WPARAM)wpFunction, 0))
            if (pf->bRunning) bChecked=TRUE;
          SendMessage(hToolbar, TB_CHECKBUTTON, lpElement->tbb.idCommand, bChecked);
        }
      }
    }
    lpElement=lpElement->next;
  }
}

void CallToolbar(HSTACK *hStack, int nItem)
{
  TOOLBARITEM *lpElement;
  EXTPARAM *lpParameter;
  wchar_t wszCurrentFile[MAX_PATH];
  wchar_t wszToolbarID[16];
  wchar_t wszItemID[16];

  if (lpElement=StackGetButtonByID(hStack, nItem))
  {
    GetCurFile(wszCurrentFile, MAX_PATH);
    xitoaW((INT_PTR)hToolbar, wszToolbarID);
    xitoaW(lpElement->tbb.idCommand, wszItemID);

    if (lpElement->dwAction == EXTACT_COMMAND)
    {
      int nCommand=0;

      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
        nCommand=lpParameter->nNumber;

      if (nCommand)
      {
        SendMessage(hMainWnd, WM_COMMAND, nCommand, 0);
      }
    }
    else if (lpElement->dwAction == EXTACT_CALL)
    {
      unsigned char *lpStruct=NULL;

      ExpandMethodParameters(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);

      if (StructMethodParameters(&lpElement->hParamStack, &lpStruct))
      {
        PLUGINCALLSENDW pcs;
        PLUGINCALLPOSTW *pcp;
        wchar_t *wpFunction=(wchar_t *)*(INT_PTR *)lpStruct;
        void *lpCallParam=lpStruct + sizeof(INT_PTR);
        INT_PTR nCallParamSize=*(INT_PTR *)(lpStruct + sizeof(INT_PTR));
        BOOL bCall=FALSE;

        if (lpElement->bAutoLoad)
        {
          pcs.pFunction=wpFunction;
          pcs.lParam=0;
          pcs.dwSupport=0;

          if (SendMessage(hMainWnd, AKD_DLLCALLW, DLLCF_GETSUPPORT, (LPARAM)&pcs) != UD_FAILED)
          {
            if (pcs.dwSupport & PDS_NOAUTOLOAD)
            {
              xprintfW(wszBuffer, GetLangStringW(wLangModule, STRID_AUTOLOAD), wpFunction);
              MessageBoxW(hMainWnd, wszBuffer, GetLangStringW(wLangModule, STRID_PLUGIN), MB_OK|MB_ICONEXCLAMATION);
            }
            else bCall=TRUE;
          }
        }
        else bCall=TRUE;

        if (bCall)
        {
          if (pcp=(PLUGINCALLPOSTW *)GlobalAlloc(GPTR, sizeof(PLUGINCALLPOSTW) + nCallParamSize))
          {
            xstrcpynW(pcp->szFunction, wpFunction, MAX_PATH);
            if (nCallParamSize > (INT_PTR)sizeof(INT_PTR))
            {
              //Copy parameters structure
              pcp->lParam=(LPARAM)((unsigned char *)pcp + sizeof(PLUGINCALLPOSTW));
              xmemcpy((void *)pcp->lParam, lpCallParam, nCallParamSize);
            }
            else pcp->lParam=0;

            PostMessage(hMainWnd, AKD_DLLCALLW, (lpElement->bAutoLoad?DLLCF_SWITCHAUTOLOAD|DLLCF_SAVEONEXIT:0), (LPARAM)pcp);
          }
        }
        GlobalFree((HGLOBAL)lpStruct);
      }
    }
    else if (lpElement->dwAction == EXTACT_EXEC)
    {
      STARTUPINFOW si;
      PROCESS_INFORMATION pi;
      wchar_t *wpCmdLine=NULL;
      wchar_t *wpWorkDir=NULL;
      BOOL bWait=FALSE;

      ExpandMethodParameters(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
        wpCmdLine=lpParameter->wpExpanded;
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 2))
        wpWorkDir=lpParameter->wpExpanded;
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 3))
        bWait=lpParameter->nNumber;

      if (wpCmdLine)
      {
        xmemset(&si, 0, sizeof(STARTUPINFOW));
        si.cb=sizeof(STARTUPINFOW);
        if (CreateProcessWide(NULL, wpCmdLine, NULL, NULL, FALSE, 0, NULL, (wpWorkDir && *wpWorkDir)?wpWorkDir:NULL, &si, &pi))
        {
          if (bWait)
          {
            WaitForSingleObject(pi.hProcess, INFINITE);
            //GetExitCodeProcess(pi.hProcess, &dwExit);
          }
          CloseHandle(pi.hProcess);
          CloseHandle(pi.hThread);
        }
      }
    }
    else if (lpElement->dwAction == EXTACT_OPENFILE ||
             lpElement->dwAction == EXTACT_SAVEFILE)
    {
      wchar_t *wpFile=NULL;
      int nCodePage=-1;
      BOOL bBOM=-1;

      ExpandMethodParameters(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
        wpFile=lpParameter->wpExpanded;
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 2))
        nCodePage=lpParameter->nNumber;
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 3))
        bBOM=lpParameter->nNumber;

      if (lpElement->dwAction == EXTACT_OPENFILE)
      {
        OPENDOCUMENTW od;

        od.dwFlags=OD_ADT_BINARY_ERROR;
        if (nCodePage == -1) od.dwFlags|=OD_ADT_DETECT_CODEPAGE;
        if (bBOM == -1) od.dwFlags|=OD_ADT_DETECT_BOM;

        od.pFile=wpFile;
        od.pWorkDir=NULL;
        od.nCodePage=nCodePage;
        od.bBOM=bBOM;
        SendMessage(hMainWnd, AKD_OPENDOCUMENTW, (WPARAM)NULL, (LPARAM)&od);
      }
      else if (lpElement->dwAction == EXTACT_SAVEFILE)
      {
        EDITINFO ei;
        SAVEDOCUMENTW sd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (nCodePage == -1)
            nCodePage=ei.nCodePage;
          if (bBOM == -1)
            bBOM=ei.bBOM;
          sd.pFile=wpFile;
          sd.nCodePage=nCodePage;
          sd.bBOM=bBOM;
          sd.dwFlags=SD_UPDATE;
          SendMessage(hMainWnd, AKD_SAVEDOCUMENTW, (WPARAM)NULL, (LPARAM)&sd);
        }
      }
    }
    else if (lpElement->dwAction == EXTACT_FONT)
    {
      EDITINFO ei;
      LOGFONTW lfNew;
      HDC hDC;
      wchar_t *wpFaceName=NULL;
      DWORD dwFontStyle=0;
      int nPointSize=0;

      ExpandMethodParameters(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
        wpFaceName=lpParameter->wpExpanded;
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 2))
        dwFontStyle=lpParameter->nNumber;
      if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 3))
        nPointSize=lpParameter->nNumber;

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        if (SendMessage(hMainWnd, AKD_GETFONTW, (WPARAM)ei.hWndEdit, (LPARAM)&lfNew))
        {
          if (nPointSize)
          {
            if (hDC=GetDC(ei.hWndEdit))
            {
              lfNew.lfHeight=-MulDiv(nPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
              ReleaseDC(ei.hWndEdit, hDC);
            }
          }
          if (dwFontStyle != FS_NONE)
          {
            lfNew.lfWeight=(dwFontStyle == FS_FONTBOLD || dwFontStyle == FS_FONTBOLDITALIC)?FW_BOLD:FW_NORMAL;
            lfNew.lfItalic=(dwFontStyle == FS_FONTITALIC || dwFontStyle == FS_FONTBOLDITALIC)?TRUE:FALSE;
          }
          if (*wpFaceName != '\0')
          {
            xstrcpynW(lfNew.lfFaceName, wpFaceName, LF_FACESIZE);
          }
          SendMessage(hMainWnd, AKD_SETFONTW, (WPARAM)ei.hWndEdit, (LPARAM)&lfNew);
        }
      }
    }
    else if (lpElement->dwAction == EXTACT_RECODE)
    {
      EDITINFO ei;
      TEXTRECODE tr={0};

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
          tr.nCodePageFrom=lpParameter->nNumber;
        if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 2))
          tr.nCodePageTo=lpParameter->nNumber;

        SendMessage(hMainWnd, AKD_RECODESEL, (WPARAM)ei.hWndEdit, (LPARAM)&tr);
      }
    }
    else if (lpElement->dwAction == EXTACT_INSERT)
    {
      EDITINFO ei;
      wchar_t *wpText=NULL;
      wchar_t *wpUnescText=NULL;
      int nTextLen=-1;
      int nUnescTextLen;
      DWORD dwCaret=(DWORD)-1;
      BOOL bEscSequences=FALSE;

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        if (!ei.bReadOnly)
        {
          ExpandMethodParameters(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
          if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 1))
            wpText=lpParameter->wpExpanded;
          if (lpParameter=GetMethodParameter(&lpElement->hParamStack, 2))
            bEscSequences=lpParameter->nNumber;

          if (bEscSequences)
          {
            if (nUnescTextLen=(int)TranslateEscapeString(ei.hWndEdit, wpText, NULL, NULL))
            {
              if (wpUnescText=(wchar_t *)GlobalAlloc(GPTR, nUnescTextLen * sizeof(wchar_t)))
              {
                nTextLen=(int)TranslateEscapeString(ei.hWndEdit, wpText, wpUnescText, &dwCaret);
                wpText=wpUnescText;
              }
            }
          }
          if (wpText)
          {
            AEREPLACESELW rs;
            AECHARINDEX ciInsertPos;

            rs.pText=wpText;
            rs.dwTextLen=(UINT_PTR)nTextLen;
            rs.nNewLine=AELB_ASINPUT;
            rs.bColumnSel=-1;
            rs.ciInsertStart=&ciInsertPos;
            rs.ciInsertEnd=NULL;
            SendMessage(ei.hWndEdit, AEM_REPLACESELW, 0, (LPARAM)&rs);

            if (dwCaret != (DWORD)-1)
            {
              AEINDEXOFFSET io;

              io.ciCharIn=&ciInsertPos;
              io.ciCharOut=&ciInsertPos;
              io.nOffset=dwCaret;
              io.nNewLine=AELB_ASINPUT;
              SendMessage(ei.hWndEdit, AEM_INDEXOFFSET, 0, (LPARAM)&io);
              SendMessage(ei.hWndEdit, AEM_EXSETSEL, (WPARAM)&ciInsertPos, (LPARAM)&ciInsertPos);
            }
          }
          if (wpUnescText) GlobalFree((HGLOBAL)wpUnescText);
        }
      }
    }
  }
}

void DestroyToolbarWindow(BOOL bDestroyBG)
{
  DestroyWindow(hToolbar);
  hToolbar=NULL;
  FreeToolbarData(&hToolbarStack);

  if (bDestroyBG)
  {
    DestroyWindow(hToolbarBG);
    hToolbarBG=NULL;
    UnregisterClassWide(TOOLBARBACKGROUNDW, hInstanceDLL);
  }
}

TOOLBARITEM* StackInsertButton(HSTACK *hStack)
{
  TOOLBARITEM *lpElement=NULL;

  StackInsertIndex((stack **)&hStack->first, (stack **)&hStack->last, (stack **)&lpElement, -1, sizeof(TOOLBARITEM));
  return lpElement;
}

TOOLBARITEM* StackGetButtonByID(HSTACK *hStack, int nItemID)
{
  TOOLBARITEM *lpElement=(TOOLBARITEM *)hStack->first;

  while (lpElement)
  {
    if (lpElement->tbb.idCommand == nItemID)
      return lpElement;

    lpElement=lpElement->next;
  }
  return NULL;
}

TOOLBARITEM* StackGetButtonByIndex(HSTACK *hStack, int nIndex)
{
  TOOLBARITEM *lpElement=(TOOLBARITEM *)hStack->first;
  int nCount=0;

  while (lpElement)
  {
    if (nCount++ == nIndex)
      return lpElement;

    lpElement=lpElement->next;
  }
  return NULL;
}

void StackFreeButton(HSTACK *hStack)
{
  TOOLBARITEM *lpElement=(TOOLBARITEM *)hStack->first;

  while (lpElement)
  {
    FreeMethodParameters(&lpElement->hParamStack);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hStack->first, (stack **)&hStack->last);
}

void ParseMethodParameters(STACKEXTPARAM *hParamStack, const wchar_t *wpText, const wchar_t **wppText)
{
  EXTPARAM *lpParameter;
  const wchar_t *wpParamBegin=wpText;
  const wchar_t *wpParamEnd;
  wchar_t *wpString;
  wchar_t wchStopChar;
  int nStringLen;

  MethodParameter:
  while (*wpParamBegin == ' ' || *wpParamBegin == '\t') ++wpParamBegin;

  if (*wpParamBegin == '\"' || *wpParamBegin == '\'' || *wpParamBegin == '`')
  {
    //String
    wchStopChar=*wpParamBegin++;
    nStringLen=0;

    for (wpParamEnd=wpParamBegin; *wpParamEnd != wchStopChar && *wpParamEnd != '\0'; ++wpParamEnd)
      ++nStringLen;

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(EXTPARAM)))
    {
      ++hParamStack->nElements;

      if (lpParameter->wpString=(wchar_t *)GlobalAlloc(GPTR, (nStringLen + 1) * sizeof(wchar_t)))
      {
        lpParameter->dwType=EXTPARAM_CHAR;
        wpString=lpParameter->wpString;

        for (wpParamEnd=wpParamBegin; *wpParamEnd != wchStopChar && *wpParamEnd != '\0'; ++wpParamEnd)
          *wpString++=*wpParamEnd;
        *wpString='\0';

        if (bOldWindows)
        {
          nStringLen=WideCharToMultiByte(CP_ACP, 0, lpParameter->wpString, -1, NULL, 0, NULL, NULL);
          if (lpParameter->pString=(char *)GlobalAlloc(GPTR, nStringLen))
            WideCharToMultiByte(CP_ACP, 0, lpParameter->wpString, -1, lpParameter->pString, nStringLen, NULL, NULL);
        }
      }
    }
  }
  else
  {
    //Number
    for (wpParamEnd=wpParamBegin; *wpParamEnd != ',' && *wpParamEnd != ')' && *wpParamEnd != '\0'; ++wpParamEnd);

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(EXTPARAM)))
    {
      ++hParamStack->nElements;

      lpParameter->dwType=EXTPARAM_INT;
      lpParameter->nNumber=(int)xatoiW(wpParamBegin, NULL);
    }
  }

  while (*wpParamEnd != ',' && *wpParamEnd != ')' && *wpParamEnd != '\0')
    ++wpParamEnd;
  if (*wpParamEnd == ',')
  {
    wpParamBegin=++wpParamEnd;
    goto MethodParameter;
  }
  if (*wpParamEnd == ')')
    ++wpParamEnd;
  if (wppText) *wppText=wpParamEnd;
}

void ExpandMethodParameters(STACKEXTPARAM *hParamStack, const wchar_t *wpFile, const wchar_t *wpExeDir, const wchar_t *wpToolbarID, const wchar_t *wpItemID)
{
  //%f -file, %d -file directory, %a -AkelPad directory, %% -%
  EXTPARAM *lpParameter;
  wchar_t wszFileDir[MAX_PATH];
  wchar_t *wszString;
  wchar_t *wpCount;
  wchar_t *wpExpandStr;
  int nFileLen;
  int nFileDirLen;
  int nExeDirLen;
  int nToolbarIDLen;
  int nItemIDLen;
  int nExpandStrLen;
  int nEnvironmentLen;

  nFileLen=lstrlenW(wpFile);
  nFileDirLen=GetFileDir(wpFile, wszFileDir, MAX_PATH);
  nExeDirLen=lstrlenW(wpExeDir);
  nToolbarIDLen=lstrlenW(wpToolbarID);
  nItemIDLen=lstrlenW(wpItemID);
  nExpandStrLen=0;

  for (lpParameter=hParamStack->first; lpParameter; lpParameter=lpParameter->next)
  {
    if (lpParameter->dwType == EXTPARAM_CHAR)
    {
      nEnvironmentLen=ExpandEnvironmentStringsWide(lpParameter->wpString, NULL, 0);

      if (wszString=(wchar_t *)GlobalAlloc(GPTR, nEnvironmentLen * sizeof(wchar_t)))
      {
        //Expand environment strings
        ExpandEnvironmentStringsWide(lpParameter->wpString, wszString, nEnvironmentLen);

        //Calculate expanded size
        for (wpCount=wszString; *wpCount; ++wpCount)
        {
          if (*wpCount == '%')
          {
            if (*(wpCount + 1) == '%')
            {
              ++wpCount;
              ++nExpandStrLen;
              continue;
            }
            if (*(wpCount + 1) == 'f' || *(wpCount + 1) == 'F')
            {
              ++wpCount;
              nExpandStrLen+=nFileLen;
              continue;
            }
            if (*(wpCount + 1) == 'd' || *(wpCount + 1) == 'D')
            {
              ++wpCount;
              nExpandStrLen+=nFileDirLen;
              continue;
            }
            if (*(wpCount + 1) == 'a' || *(wpCount + 1) == 'A')
            {
              ++wpCount;
              nExpandStrLen+=nExeDirLen;
              continue;
            }
            if (*(wpCount + 1) == 'm' || *(wpCount + 1) == 'M')
            {
              ++wpCount;
              nExpandStrLen+=nToolbarIDLen;
              continue;
            }
            if (*(wpCount + 1) == 'i' || *(wpCount + 1) == 'I')
            {
              ++wpCount;
              nExpandStrLen+=nItemIDLen;
              continue;
            }
          }
          else ++nExpandStrLen;
        }

        //Expand string
        if (lpParameter->pExpanded)
        {
          GlobalFree((HGLOBAL)lpParameter->pExpanded);
          lpParameter->pExpanded=NULL;
        }
        if (lpParameter->wpExpanded)
        {
          GlobalFree((HGLOBAL)lpParameter->wpExpanded);
          lpParameter->wpExpanded=NULL;
        }

        if (lpParameter->wpExpanded=(wchar_t *)GlobalAlloc(GPTR, (nExpandStrLen + 1) * sizeof(wchar_t)))
        {
          wpExpandStr=lpParameter->wpExpanded;

          for (wpCount=wszString; *wpCount; ++wpCount)
          {
            if (*wpCount == '%')
            {
              if (*(wpCount + 1) == '%')
              {
                ++wpCount;
                *wpExpandStr++='%';
                continue;
              }
              if (*(wpCount + 1) == 'f' || *(wpCount + 1) == 'F')
              {
                ++wpCount;
                xstrcpyW(wpExpandStr, wpFile);
                wpExpandStr+=nFileLen;
                continue;
              }
              if (*(wpCount + 1) == 'd' || *(wpCount + 1) == 'D')
              {
                ++wpCount;
                xstrcpyW(wpExpandStr, wszFileDir);
                wpExpandStr+=nFileDirLen;
                continue;
              }
              if (*(wpCount + 1) == 'a' || *(wpCount + 1) == 'A')
              {
                ++wpCount;
                xstrcpyW(wpExpandStr, wpExeDir);
                wpExpandStr+=nExeDirLen;
                continue;
              }
              if (*(wpCount + 1) == 'm' || *(wpCount + 1) == 'M')
              {
                ++wpCount;
                xstrcpyW(wpExpandStr, wpToolbarID);
                wpExpandStr+=nToolbarIDLen;
                continue;
              }
              if (*(wpCount + 1) == 'i' || *(wpCount + 1) == 'I')
              {
                ++wpCount;
                xstrcpyW(wpExpandStr, wpItemID);
                wpExpandStr+=nItemIDLen;
                continue;
              }
            }
            else *wpExpandStr++=*wpCount;
          }
          *wpExpandStr='\0';

          if (bOldWindows)
          {
            nExpandStrLen=WideCharToMultiByte(CP_ACP, 0, lpParameter->wpExpanded, -1, NULL, 0, NULL, NULL);
            if (lpParameter->pExpanded=(char *)GlobalAlloc(GPTR, nExpandStrLen))
              WideCharToMultiByte(CP_ACP, 0, lpParameter->wpExpanded, -1, lpParameter->pExpanded, nExpandStrLen, NULL, NULL);
          }
        }
        GlobalFree((HGLOBAL)wszString);
      }
    }
  }
}

int StructMethodParameters(STACKEXTPARAM *hParamStack, unsigned char **lppStruct)
{
  EXTPARAM *lpParameter;
  unsigned char *lpStruct=NULL;
  int nStructSize=0;
  int nOffset=0;
  int nIndex=0;

  if (hParamStack->nElements)
  {
    nStructSize=(hParamStack->nElements + 1) * sizeof(INT_PTR);

    if (lpStruct=(unsigned char *)GlobalAlloc(GPTR, nStructSize))
    {
      for (lpParameter=hParamStack->first; lpParameter; lpParameter=lpParameter->next)
      {
        if (nIndex == 1)
        {
          //nIndex == 1 is the size of the call parameters structure
          *((INT_PTR *)(lpStruct + nOffset))=hParamStack->nElements * sizeof(INT_PTR);
          nOffset+=sizeof(INT_PTR);
          ++nIndex;
        }

        //nIndex == 0 is function name, nIndex >= 2 is call parameters
        if (lpParameter->dwType == EXTPARAM_CHAR)
        {
          if (bOldWindows && nIndex > 0)
            *((INT_PTR *)(lpStruct + nOffset))=(INT_PTR)lpParameter->pExpanded;
          else
            *((INT_PTR *)(lpStruct + nOffset))=(INT_PTR)lpParameter->wpExpanded;
        }
        else *((INT_PTR *)(lpStruct + nOffset))=lpParameter->nNumber;

        nOffset+=sizeof(INT_PTR);
        ++nIndex;
      }
    }
  }
  *lppStruct=lpStruct;
  return nStructSize;
}

EXTPARAM* GetMethodParameter(STACKEXTPARAM *hParamStack, int nIndex)
{
  EXTPARAM *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
    return lpParameter;
  return NULL;
}

void GetIconParameters(const wchar_t *wpText, wchar_t *wszIconFile, int nMaxIconFile, int *nIconIndex, const wchar_t **wppText)
{
  wchar_t wchStopChar;
  int i;

  wszIconFile[0]='\0';
  *nIconIndex=0;

  //File
  while (*wpText == ' ' || *wpText == '\t') ++wpText;

  if (*wpText == '\"' || *wpText == '\'' || *wpText == '`')
  {
    wchStopChar=*wpText++;

    for (i=0; i < nMaxIconFile && *wpText != wchStopChar && *wpText != '\0'; ++i, ++wpText)
    {
      wszIconFile[i]=*wpText;
    }
    wszIconFile[i]='\0';

    while (*wpText != ',' && *wpText != ')' && *wpText != '\0')
      ++wpText;
    if (*wpText == ',')
      ++wpText;
    else
      goto End;
  }

  //Index
  while (*wpText == ' ' || *wpText == '\t') ++wpText;

  *nIconIndex=(int)xatoiW(wpText, NULL);

  while (*wpText != ',' && *wpText != ')' && *wpText != '\0')
    ++wpText;
  if (*wpText == ',')
    ++wpText;
  else
    goto End;

  //End
  End:
  if (*wpText == ')')
    ++wpText;
  *wppText=wpText;
}

void FreeMethodParameters(STACKEXTPARAM *hParamStack)
{
  EXTPARAM *lpParameter;

  for (lpParameter=hParamStack->first; lpParameter; lpParameter=lpParameter->next)
  {
    if (lpParameter->dwType == EXTPARAM_CHAR)
    {
      if (lpParameter->pString) GlobalFree((HGLOBAL)lpParameter->pString);
      if (lpParameter->wpString) GlobalFree((HGLOBAL)lpParameter->wpString);
      if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);
      if (lpParameter->wpExpanded) GlobalFree((HGLOBAL)lpParameter->wpExpanded);
    }
  }
  StackClear((stack **)&hParamStack->first, (stack **)&hParamStack->last);
  hParamStack->nElements=0;
}

int GetMethodName(const wchar_t *wpText, wchar_t *wszStr, int nStrLen, const wchar_t **wppText)
{
  int i=0;

  while (*wpText == '\"' || *wpText == ' ' || *wpText == '\t') ++wpText;

  while (*wpText != '(' && *wpText != '\r' && *wpText != '\0')
  {
    if (i < nStrLen) wszStr[i++]=*wpText;
    ++wpText;
  }
  wszStr[i]='\0';
  if (*wpText != '\r' && *wpText != '\0') ++wpText;
  if (wppText) *wppText=wpText;
  return i;
}

int NextString(const wchar_t *wpText, wchar_t *wszStr, int nStrLen, const wchar_t **wppText, int *nMinus)
{
  int i;

  while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r' || *wpText == '\n') ++wpText;

  if (*wpText == '-')
  {
    if (nMinus) *nMinus=1;
    ++wpText;
  }
  else
  {
    if (nMinus) *nMinus=0;
  }

  if (*wpText == '\"')
  {
    ++wpText;
    i=0;

    while (*wpText != '\"' && *wpText != '\0')
    {
      if (i < nStrLen) wszStr[i++]=*wpText;
      ++wpText;
    }
  }
  else
  {
    i=0;

    while (*wpText != ' ' && *wpText != '\r' && *wpText != '\0')
    {
      if (i < nStrLen) wszStr[i++]=*wpText;
      ++wpText;
    }
  }
  wszStr[i]='\0';
  if (*wpText != '\r' && *wpText != '\0') ++wpText;
  if (wppText) *wppText=wpText;
  return i;
}

BOOL SkipComment(const wchar_t **wpText)
{
  for (;;)
  {
    while (**wpText == ' ' || **wpText == '\t' || **wpText == '\r' || **wpText == '\n') ++*wpText;

    if (**wpText == ';' || **wpText == '#')
    {
      while (**wpText != '\r' && **wpText != '\0') ++*wpText;
    }
    else break;
  }
  if (**wpText == '\0')
    return FALSE;
  return TRUE;
}

int GetFileDir(const wchar_t *wpFile, wchar_t *wszFileDir, int nFileDirLen)
{
  int i;

  if (!nFileDirLen) return 0;
  wszFileDir[0]='\0';

  for (i=lstrlenW(wpFile) - 1; i > 0; --i)
  {
    if (wpFile[i] == '\\')
    {
      i=min(nFileDirLen, i + 1);
      xstrcpynW(wszFileDir, wpFile, i);
      return (i - 1);
    }
  }
  return 0;
}

INT_PTR TranslateEscapeString(HWND hWndEdit, const wchar_t *wpInput, wchar_t *wszOutput, DWORD *lpdwCaret)
{
  EDITINFO ei;
  const wchar_t *a=wpInput;
  wchar_t *b=wszOutput;
  wchar_t whex[5];
  int nDec;

  if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)hWndEdit, (LPARAM)&ei))
  {
    for (whex[4]='\0'; *a; ++a)
    {
      if (*a == '\\')
      {
        if (*++a == '\\')
        {
          if (wszOutput) *b='\\';
          ++b;
        }
        else if (*a == 'n')
        {
          if (ei.nNewLine == NEWLINE_MAC)
          {
            if (wszOutput) *b='\r';
            ++b;
          }
          else if (ei.nNewLine == NEWLINE_UNIX)
          {
            if (wszOutput) *b='\n';
            ++b;
          }
          else if (ei.nNewLine == NEWLINE_WIN)
          {
            if (wszOutput) *b='\r';
            ++b;
            if (wszOutput) *b='\n';
            ++b;
          }
        }
        else if (*a == 't')
        {
          if (wszOutput) *b='\t';
          ++b;
        }
        else if (*a == '[')
        {
          while (*++a == ' ');

          do
          {
            whex[0]=*a;
            if (!*a) goto Error;
            whex[1]=*++a;
            if (!*a) goto Error;
            whex[2]=*++a;
            if (!*a) goto Error;
            whex[3]=*++a;
            if (!*a) goto Error;
            nDec=(int)hex2decW(whex);
            if (nDec == -1) goto Error;
            while (*++a == ' ');

            if (wszOutput) *b=(wchar_t)nDec;
            ++b;
          }
          while (*a && *a != ']');

          if (!*a) goto Error;
        }
        else if (*a == 's')
        {
          CHARRANGE64 cr;

          SendMessage(hWndEdit, EM_EXGETSEL64, 0, (WPARAM)&cr);
          if (cr.cpMin != cr.cpMax)
          {
            if (wszOutput)
            {
              wchar_t *wpText;
              INT_PTR nTextLen=0;

              if (wpText=(wchar_t *)SendMessage(hMainWnd, AKD_GETSELTEXTW, (WPARAM)hWndEdit, (LPARAM)&nTextLen))
              {
                xmemcpy(b, wpText, nTextLen * sizeof(wchar_t));
                b+=nTextLen;
                SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)wpText);
              }
            }
            else b+=cr.cpMax - cr.cpMin;
          }
        }
        else if (*a == '|')
        {
          if (lpdwCaret) *lpdwCaret=(DWORD)(b - wszOutput);
        }
        else goto Error;
      }
      else
      {
        if (wszOutput) *b=*a;
        ++b;
      }
    }
    if (wszOutput)
      *b='\0';
    else
      ++b;
    return (b - wszOutput);
  }

  Error:
  if (wszOutput) *wszOutput='\0';
  return 0;
}

int TranslateFileString(const wchar_t *wpString, wchar_t *wszBuffer, int nBufferSize)
{
  //%a -AkelPad directory, %% -%
  wchar_t *wpExeDir=wszExeDir;
  wchar_t *wszString;
  int nEnvironmentLen;
  int nExeDirLen;
  int a=0;
  int b=0;

  nExeDirLen=lstrlenW(wpExeDir);
  nEnvironmentLen=ExpandEnvironmentStringsWide(wpString, NULL, 0);

  if (wszString=(wchar_t *)GlobalAlloc(GPTR, nEnvironmentLen * sizeof(wchar_t)))
  {
    //Expand environment strings
    ExpandEnvironmentStringsWide(wpString, wszString, nEnvironmentLen);
    wpString=wszString;

    for (; wpString[a] && (!wszBuffer || b < nBufferSize); ++a, ++b)
    {
      if (wpString[a] == '%')
      {
        if (wpString[++a] == '%')
        {
          if (wszBuffer) wszBuffer[b]='%';
        }
        else if (wpString[a] == 'a' || wpString[a] == 'A')
        {
          if (!wszBuffer || b + nExeDirLen <= nBufferSize)
          {
            if (wszBuffer) xstrcpyW(wszBuffer + b, wpExeDir);
            b+=nExeDirLen - 1;
          }
          else break;
        }
        else break;
      }
      else if (wszBuffer) wszBuffer[b]=wpString[a];
    }
    GlobalFree((HGLOBAL)wszString);
  }
  if (wszBuffer && b < nBufferSize) wszBuffer[b]='\0';
  return b;
}

int GetCurFile(wchar_t *wszFile, int nMaxFile)
{
  EDITINFO ei;

  if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
  {
    return (int)xstrcpynW(wszFile, ei.wszFile, nMaxFile) + 1;
  }
  wszFile[0]='\0';
  return 0;
}

INT_PTR GetEditText(HWND hWnd, wchar_t **wpText)
{
  GETTEXTRANGE gtr;
  INT_PTR nTextLen;

  gtr.cpMin=0;
  gtr.cpMax=-1;

  if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGEW, (WPARAM)hWnd, (LPARAM)&gtr))
    *wpText=(wchar_t *)gtr.pText;
  else
    *wpText=(wchar_t *)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, sizeof(wchar_t));
  return nTextLen;
}

void ShowStandardEditMenu(HWND hWnd, HMENU hMenu, BOOL bMouse)
{
  POINT pt;
  CHARRANGE64 cr;
  int nCmd;

  if (!bMouse && SendMessage(hWnd, AEM_GETCARETPOS, (WPARAM)&pt, 0))
  {
    pt.y+=(int)SendMessage(hWnd, AEM_GETCHARSIZE, AECS_HEIGHT, 0);
    ClientToScreen(hWnd, &pt);
  }
  else GetCursorPos(&pt);

  SendMessage(hWnd, EM_EXGETSEL64, 0, (LPARAM)&cr);
  EnableMenuItem(hMenu, IDM_EDIT_UNDO, SendMessage(hWnd, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_REDO, SendMessage(hWnd, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_PASTE, SendMessage(hWnd, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_CUT, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_CLEAR, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_COPY, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);

  nCmd=TrackPopupMenu(hMenu, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);

  if (nCmd == IDM_EDIT_UNDO)
    SendMessage(hWnd, EM_UNDO, 0, 0);
  else if (nCmd == IDM_EDIT_REDO)
    SendMessage(hWnd, EM_REDO, 0, 0);
  else if (nCmd == IDM_EDIT_CUT)
    SendMessage(hWnd, WM_CUT, 0, 0);
  else if (nCmd == IDM_EDIT_COPY)
    SendMessage(hWnd, WM_COPY, 0, 0);
  else if (nCmd == IDM_EDIT_PASTE)
    SendMessage(hWnd, WM_PASTE, 0, 0);
  else if (nCmd == IDM_EDIT_CLEAR)
    SendMessage(hWnd, WM_CLEAR, 0, 0);
  else if (nCmd == IDM_EDIT_SELECTALL)
    SendMessage(hWnd, EM_SETSEL, 0, -1);
}

DWORD ScrollCaret(HWND hWnd)
{
  AESCROLLTOPOINT stp;
  DWORD dwScrollResult;

  //Test scroll to caret
  stp.dwFlags=AESC_TEST|AESC_POINTCARET|AESC_OFFSETCHARX|AESC_OFFSETCHARY;
  stp.nOffsetX=1;
  stp.nOffsetY=0;
  dwScrollResult=(DWORD)SendMessage(hWnd, AEM_SCROLLTOPOINT, 0, (LPARAM)&stp);

  //Scroll to caret
  stp.dwFlags=AESC_POINTCARET;
  stp.nOffsetX=3;
  stp.nOffsetY=2;
  if (dwScrollResult & AECSE_SCROLLEDX)
    stp.dwFlags|=AESC_OFFSETRECTDIVX;
  if (dwScrollResult & AECSE_SCROLLEDY)
    stp.dwFlags|=AESC_OFFSETRECTDIVY;
  return (DWORD)SendMessage(hWnd, AEM_SCROLLTOPOINT, 0, (LPARAM)&stp);
}


//// Options

INT_PTR WideOption(HANDLE hOptions, const wchar_t *pOptionName, DWORD dwType, BYTE *lpData, DWORD dwData)
{
  PLUGINOPTIONW po;

  po.pOptionName=pOptionName;
  po.dwType=dwType;
  po.lpData=lpData;
  po.dwData=dwData;
  return SendMessage(hMainWnd, AKD_OPTIONW, (WPARAM)hOptions, (LPARAM)&po);
}

void ReadOptions(DWORD dwFlags)
{
  HANDLE hOptions;
  DWORD dwSize;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONSW, POB_READ, (LPARAM)wszPluginName))
  {
    dwSize=(DWORD)WideOption(hOptions, L"ToolBarText", PO_BINARY, NULL, 0);

    if (dwSize)
    {
      if (wszToolBarText=(wchar_t *)HeapAlloc(hHeap, 0, dwSize + sizeof(wchar_t)))
      {
        WideOption(hOptions, L"ToolBarText", PO_BINARY, (LPBYTE)wszToolBarText, dwSize);
        wszToolBarText[dwSize / sizeof(wchar_t)]=L'\0';
      }
    }

    WideOption(hOptions, L"BigIcons", PO_DWORD, (LPBYTE)&bBigIcons, sizeof(DWORD));
    WideOption(hOptions, L"FlatButtons", PO_DWORD, (LPBYTE)&bFlatButtons, sizeof(DWORD));
    WideOption(hOptions, L"IconsBit", PO_DWORD, (LPBYTE)&nIconsBit, sizeof(DWORD));
    WideOption(hOptions, L"ToolbarSide", PO_DWORD, (LPBYTE)&nToolbarSide, sizeof(DWORD));
    WideOption(hOptions, L"WindowRect", PO_BINARY, (LPBYTE)&rcMainCurrentDialog, sizeof(RECT));

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }

  if (!wszToolBarText)
  {
    dwSize=(DWORD)xprintfW(NULL, L"%s%s%s%s",
                                 TXT_DEFAULT_PART1W,
                                 TXT_DEFAULT_PART2W,
                                 TXT_DEFAULT_PART3W,
                                 TXT_DEFAULT_PART4W);

    if (wszToolBarText=(wchar_t *)HeapAlloc(hHeap, 0, dwSize * sizeof(wchar_t)))
    {
      xprintfW(wszToolBarText, L"%s%s%s%s",
                                 TXT_DEFAULT_PART1W,
                                 TXT_DEFAULT_PART2W,
                                 TXT_DEFAULT_PART3W,
                                 TXT_DEFAULT_PART4W);
    }
  }
}

void SaveOptions(DWORD dwFlags)
{
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONSW, POB_SAVE, (LPARAM)wszPluginName))
  {
    if (dwFlags & OF_LISTTEXT)
    {
      WideOption(hOptions, L"ToolBarText", PO_BINARY, (LPBYTE)wszToolBarText, (lstrlenW(wszToolBarText) + 1) * sizeof(wchar_t));
    }
    if (dwFlags & OF_SETTINGS)
    {
      WideOption(hOptions, L"BigIcons", PO_DWORD, (LPBYTE)&bBigIcons, sizeof(DWORD));
      WideOption(hOptions, L"FlatButtons", PO_DWORD, (LPBYTE)&bFlatButtons, sizeof(DWORD));
      WideOption(hOptions, L"IconsBit", PO_DWORD, (LPBYTE)&nIconsBit, sizeof(DWORD));
      WideOption(hOptions, L"ToolbarSide", PO_DWORD, (LPBYTE)&nToolbarSide, sizeof(DWORD));
    }
    if (dwFlags & OF_RECT)
    {
      WideOption(hOptions, L"WindowRect", PO_BINARY, (LPBYTE)&rcMainCurrentDialog, sizeof(RECT));
    }

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

const char* GetLangStringA(LANGID wLangID, int nStringID)
{
  static char szStringBuf[MAX_PATH];

  WideCharToMultiByte(CP_ACP, 0, GetLangStringW(wLangID, nStringID), -1, szStringBuf, MAX_PATH, NULL, NULL);
  return szStringBuf;
}

const wchar_t* GetLangStringW(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_SETUP)
      return L"\x041D\x0430\x0441\x0442\x0440\x043E\x0438\x0442\x044C\x002E\x002E\x002E";
    if (nStringID == STRID_AUTOLOAD)
      return L"\x0022\x0025\x0073\x0022\x0020\x043D\x0435\x0020\x043F\x043E\x0434\x0434\x0435\x0440\x0436\x0438\x0432\x0430\x0435\x0442\x0020\x0430\x0432\x0442\x043E\x0437\x0430\x0433\x0440\x0443\x0437\x043A\x0443\x0020\x0028\x0022\x002B\x0022\x0020\x043F\x0435\x0440\x0435\x0434\x0020\x0022\x0043\x0061\x006C\x006C\x0022\x0029\x002E";
    if (nStringID == STRID_BIGICONS)
      return L"\x0411\x043E\x043B\x044C\x0448\x0438\x0435\x0020\x0438\x043A\x043E\x043D\x043A\x0438";
    if (nStringID == STRID_FLATBUTTONS)
      return L"\x041F\x043B\x043E\x0441\x043A\x0438\x0435\x0020\x043A\x043D\x043E\x043F\x043A\x0438";
    if (nStringID == STRID_16BIT)
      return L"\x0031\x0036\x002D\x0431\x0438\x0442";
    if (nStringID == STRID_32BIT)
      return L"\x0033\x0032\x002D\x0431\x0438\x0442\x0430";
    if (nStringID == STRID_SIDE)
      return L"\x0421\x0442\x043E\x0440\x043E\x043D\x0430";
    if (nStringID == STRID_PLUGIN)
      return L"%s \x043F\x043B\x0430\x0433\x0438\x043D";
    if (nStringID == STRID_OK)
      return L"\x004F\x004B";
    if (nStringID == STRID_CANCEL)
      return L"\x041E\x0442\x043C\x0435\x043D\x0430";
  }
  else
  {
    if (nStringID == STRID_SETUP)
      return L"Customize...";
    if (nStringID == STRID_AUTOLOAD)
      return L"\"%s\" doesn't support autoload (\"+\" before \"Call\").";
    if (nStringID == STRID_BIGICONS)
      return L"Big icons";
    if (nStringID == STRID_FLATBUTTONS)
      return L"Flat buttons";
    if (nStringID == STRID_16BIT)
      return L"16-bit";
    if (nStringID == STRID_32BIT)
      return L"32-bit";
    if (nStringID == STRID_SIDE)
      return L"Side";
    if (nStringID == STRID_PLUGIN)
      return L"%s plugin";
    if (nStringID == STRID_OK)
      return L"OK";
    if (nStringID == STRID_CANCEL)
      return L"Cancel";
  }
  return L"";
}

void InitCommon(PLUGINDATA *pd)
{
  bInitCommon=TRUE;
  hInstanceDLL=pd->hInstanceDLL;
  hInstanceEXE=pd->hInstanceEXE;
  hMainWnd=pd->hMainWnd;
  hMdiClient=pd->hMdiClient;
  hMainMenu=pd->hMainMenu;
  hMenuRecentFiles=pd->hMenuRecentFiles;
  hPopupEdit=GetSubMenu(pd->hPopupMenu, MENU_POPUP_EDIT);
  hMainIcon=pd->hMainIcon;
  hGlobalAccel=pd->hGlobalAccel;
  bOldWindows=pd->bOldWindows;
  bAkelEdit=pd->bAkelEdit;
  nMDI=pd->nMDI;
  wLangModule=PRIMARYLANGID(pd->wLangModule);
  hHeap=GetProcessHeap();

  //Initialize WideFunc.h header
  WideInitialize();

  //Plugin name
  {
    int i;

    for (i=0; pd->wszFunction[i] != ':'; ++i)
      wszPluginName[i]=pd->wszFunction[i];
    wszPluginName[i]='\0';
  }
  xstrcpynW(wszExeDir, pd->wszAkelDir, MAX_PATH);
  ReadOptions(0);
}

void InitMain()
{
  bInitMain=TRUE;

  //SubClass
  NewMainProcData=NULL;
  SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NewMainProc, (LPARAM)&NewMainProcData);

  NewMainProcRetData=NULL;
  SendMessage(hMainWnd, AKD_SETMAINPROCRET, (WPARAM)NewMainProcRet, (LPARAM)&NewMainProcRetData);

  if (nMDI == WMD_MDI)
  {
    NewFrameProcRetData=NULL;
    SendMessage(hMainWnd, AKD_SETFRAMEPROCRET, (WPARAM)NewMainProcRet, (LPARAM)&NewFrameProcRetData);
  }
}

void UninitMain()
{
  bInitMain=FALSE;

  //Remove subclass
  if (NewMainProcData)
  {
    SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NULL, (LPARAM)&NewMainProcData);
    NewMainProcData=NULL;
  }
  if (NewMainProcRetData)
  {
    SendMessage(hMainWnd, AKD_SETMAINPROCRET, (WPARAM)NULL, (LPARAM)&NewMainProcRetData);
    NewMainProcRetData=NULL;
  }
  if (NewFrameProcRetData)
  {
    SendMessage(hMainWnd, AKD_SETFRAMEPROCRET, (WPARAM)NULL, (LPARAM)&NewFrameProcRetData);
    NewFrameProcRetData=NULL;
  }

  //Destroy toolbar
  DestroyToolbarWindow(TRUE);

  if (wszToolBarText)
  {
    HeapFree(hHeap, 0, wszToolBarText);
    wszToolBarText=NULL;
  }
}

//Entry point
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
  }
  return TRUE;
}
